Index: kaffe/kaffevm/baseClasses.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/baseClasses.c,v
retrieving revision 1.57
diff -u -p -r1.57 baseClasses.c
--- kaffe/kaffevm/baseClasses.c	25 Dec 2004 19:09:13 -0000	1.57
+++ kaffe/kaffevm/baseClasses.c	5 Jan 2005 14:54:20 -0000
@@ -54,8 +54,7 @@ Utf8Const* Exceptions_name;
 Utf8Const* SourceFile_name;
 Utf8Const* InnerClasses_name;
 
-static Hjava_lang_Class dummyClassClass;
-Hjava_lang_Class* ClassClass = &dummyClassClass;
+Hjava_lang_Class* ClassClass;
 Hjava_lang_Class* StringClass;
 Hjava_lang_Class* ObjectClass;
 Hjava_lang_Class* SystemClass;
@@ -251,7 +250,6 @@ abortWithEarlyClassFailure(errorInfo* ei
 	EXIT(-1);
 }
 
-
 /*
  * We need to use certain classes in the internal machine so we better
  * get them in now in a known way so we can refer back to them.
@@ -261,28 +259,34 @@ initBaseClasses(void)
 {
         errorInfo einfo;
 
-	memset(&dummyClassClass, 0, sizeof(dummyClassClass));
+        DBG(INIT, dprintf("initBaseClasses()\n"); );
+
+	/* newClass needs to access ClassClass ... */
+	ClassClass = gc_malloc(sizeof(Hjava_lang_Class), KGC_ALLOC_CLASSOBJECT);
+	if (ClassClass == NULL) {
+		postOutOfMemory(&einfo);
+		abortWithEarlyClassFailure(&einfo);
+	}
 
         /* Primitive types */
         initTypes();
 	initVerifierPrimTypes();
 
-        DBG(INIT, dprintf("initBaseClasses()\n"); );
+	loadStaticClass(&ObjectClass, OBJECTCLASS);
+	loadStaticClass(&SerialClass, SERIALCLASS);
+	loadStaticClass(&CloneClass,  CLONECLASS);
+	loadStaticClass(&ClassClass,  CLASSCLASS);
+
+	ObjectClass->head.vtable = ClassClass->vtable;
+	SerialClass->head.vtable = ClassClass->vtable;
+	CloneClass->head.vtable  = ClassClass->vtable;
+	ClassClass->head.vtable  = ClassClass->vtable;
+
+	finishTypes();
 
-        /* The base types */
-        loadStaticClass(&ObjectClass, OBJECTCLASS);
-        loadStaticClass(&SerialClass, SERIALCLASS);
-        loadStaticClass(&CloneClass, CLONECLASS);
-        loadStaticClass(&ClassClass, CLASSCLASS);
         loadStaticClass(&StringClass, STRINGCLASS);
         loadStaticClass(&SystemClass, SYSTEMCLASS);
 	
-        /* We must to a little cross tidying */
-        ObjectClass->head.vtable = ClassClass->vtable;
-        SerialClass->head.vtable = ClassClass->vtable;
-        CloneClass->head.vtable = ClassClass->vtable;
-        ClassClass->head.vtable = ClassClass->vtable;
-	
 	/* Basic types classes */
 	loadStaticClass(&javaLangVoidClass, "java/lang/Void");
 	loadStaticClass(&javaLangBooleanClass, "java/lang/Boolean");
@@ -311,9 +315,6 @@ initBaseClasses(void)
 	loadStaticClass(&javaIoIOException, "java/io/IOException");
 
 	DBG(INIT, dprintf("initBaseClasses() done\n"); );
-
-	/* Fixup primitive types */
-	finishTypes();
 	
 	if (!processClass(StringClass, CSTATE_COMPLETE, &einfo))
 		abortWithEarlyClassFailure(&einfo);
Index: kaffe/kaffevm/classMethod.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/classMethod.c,v
retrieving revision 1.131
diff -u -p -r1.131 classMethod.c
--- kaffe/kaffevm/classMethod.c	25 Dec 2004 19:09:13 -0000	1.131
+++ kaffe/kaffevm/classMethod.c	5 Jan 2005 14:54:21 -0000
@@ -577,6 +577,7 @@ DBG(STATICINIT,
 		class->processingThread = NULL;
 		
 		if (exc != 0) {
+			//printStackTrace(exc, NULL, 1);
 			if( soft_instanceof(javaLangException, exc) )
 			{
 				/* this is special-cased in throwError */
@@ -1464,7 +1465,7 @@ DBG(VMCLASSLOADER,
 );
 
 					/* Use the primordial loader. */
-					retval = findClass(ce, einfo);
+					retval = findClass(ce, NULL, einfo);
 				}
 			}
 			else
@@ -1557,7 +1558,7 @@ DBG(VMCLASSLOADER,
 		name);
 );
 
-		clazz = findClass(centry, &info);
+		clazz = findClass(centry, *class, &info);
 		if (clazz == 0) {
 			goto bad;
 		}
Index: kaffe/kaffevm/findInJar.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/findInJar.c,v
retrieving revision 1.64
diff -u -p -r1.64 findInJar.c
--- kaffe/kaffevm/findInJar.c	22 Dec 2004 00:22:04 -0000	1.64
+++ kaffe/kaffevm/findInJar.c	5 Jan 2005 14:54:21 -0000
@@ -77,12 +77,12 @@ static char* discoverClassHome(void);
  * Returns class if successful, NULL otherwise.
  */
 Hjava_lang_Class*
-findClass(classEntry* centry, errorInfo *einfo)
+findClass(classEntry* centry, Hjava_lang_Class* defaultClass, errorInfo *einfo)
 {
 	char *buf;
 	classFile hand;
 	const char* cname;
-	Hjava_lang_Class* class = NULL;
+	Hjava_lang_Class*	class = defaultClass;
 
 	cname = centry->name->data;
 
@@ -133,8 +133,8 @@ DBG(CLASSLOOKUP,
 	switch (hand.type) {
 	case CP_DIR:
 	case CP_ZIPFILE:
-		class = newClass();
-		if (class == NULL) {
+		if ((class == NULL) &&
+		    ((class = newClass()) == NULL) ) {
 			postOutOfMemory(einfo);
 			KFREE(hand.mem);
 			return (NULL);
Index: kaffe/kaffevm/gcFuncs.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/gcFuncs.c,v
retrieving revision 1.63
diff -u -p -r1.63 gcFuncs.c
--- kaffe/kaffevm/gcFuncs.c	25 Dec 2004 19:09:13 -0000	1.63
+++ kaffe/kaffevm/gcFuncs.c	5 Jan 2005 14:54:22 -0000
@@ -451,6 +451,7 @@ DBG(GCPRECISE,
         KGC_markObject(collector, gc_info, class->loader);
 	KGC_markObject(collector, gc_info, class->signers);
 	KGC_markObject(collector, gc_info, class->protectionDomain);
+	KGC_markObject(collector, gc_info, class->constructor);
 }
 
 /*****************************************************************************
Index: kaffe/kaffevm/soft.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/soft.c,v
retrieving revision 1.75
diff -u -p -r1.75 soft.c
--- kaffe/kaffevm/soft.c	27 Dec 2004 17:27:00 -0000	1.75
+++ kaffe/kaffevm/soft.c	5 Jan 2005 14:54:22 -0000
@@ -399,7 +399,7 @@ jint
 soft_instanceof(Hjava_lang_Class* c, Hjava_lang_Object* o)
 {
 	/* Null object are never instances of anything */
-	if (o == 0) {
+	if (o == NULL) {
 		return (0);
 	}
 
Index: kaffe/kaffevm/stackTrace.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/stackTrace.c,v
retrieving revision 1.45
diff -u -p -r1.45 stackTrace.c
--- kaffe/kaffevm/stackTrace.c	21 Dec 2004 08:06:37 -0000	1.45
+++ kaffe/kaffevm/stackTrace.c	5 Jan 2005 14:54:22 -0000
@@ -224,6 +224,13 @@ printStackTrace(struct Hjava_lang_Throwa
 	char* class_dot_name;
 	errorInfo einfo;
 
+	for (;;) {
+	if (unhand(o)->detailMessage != NULL) {
+		char *cstr = checkPtr (stringJava2C(unhand(o)->detailMessage));
+		dprintf ("%s\n", cstr);
+		KFREE(cstr);
+	}
+
 	vmstate = (Hjava_lang_VMThrowable*)unhand(o)->vmState;
 	if (vmstate == NULL) {
 		return;
@@ -295,6 +302,11 @@ printStackTrace(struct Hjava_lang_Throwa
 			}
 			KFREE(buf);
 		}
+	}
+		if (unhand(o)->cause == o)
+			break;
+
+		o = unhand(o)->cause;
 	}
 	if (p != NULL || !nullOK) {
 		do_execute_java_method(NULL, p, "flush", "()V", NULL, 0);
Index: kaffe/kaffevm/classMethod.h
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/classMethod.h,v
retrieving revision 1.75
diff -u -p -r1.75 classMethod.h
--- kaffe/kaffevm/classMethod.h	1 Jan 2005 11:35:43 -0000	1.75
+++ kaffe/kaffevm/classMethod.h	5 Jan 2005 14:54:23 -0000
@@ -82,6 +82,15 @@ typedef enum {
 struct Hjava_lang_Class {
 	Hjava_lang_Object	head;		/* A class is an object too */
 
+	/* these fields are also accessed from java and therefore MUST NOT BE CHANGED */
+
+	HArrayOfObject*			signers;
+	struct Hjava_security_ProtectionDomain*	protectionDomain;
+	struct Hjava_lang_Object*	vmData; /* unused for kaffe */
+	struct Hjava_lang_Object*	constructor;
+
+	/* end of fields being accessed from java */
+
 	struct _iLock*		lock;		/* Lock for internal use */
 
 	/* Link to class entry */
@@ -165,12 +174,6 @@ struct Hjava_lang_Class {
 	/** Stab type ID. */
 	int stab_id;
 #endif
-
-	/** The array of 'signer' objects; usually Certificates. */
-	HArrayOfObject*		signers;
-
-	/** The protection domain */
-	struct Hjava_security_ProtectionDomain*	protectionDomain;
 };
 
 #ifndef __DEFINED_CLASS
@@ -494,7 +497,7 @@ bool			processClass(Hjava_lang_Class*, i
 
 Hjava_lang_Class*	loadClass(Utf8Const*, Hjava_lang_ClassLoader*, errorInfo *einfo);
 Hjava_lang_Class*	loadArray(Utf8Const*, Hjava_lang_ClassLoader*, errorInfo *einfo);
-Hjava_lang_Class* 	findClass(struct _classEntry* centry, errorInfo *einfo);
+Hjava_lang_Class*	findClass(struct _classEntry* centry, Hjava_lang_Class*, errorInfo *einfo);
 
 void			loadStaticClass(Hjava_lang_Class**, const char*);
 
Index: libraries/javalib/java/lang/Boolean.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Boolean.java,v
retrieving revision 1.14
diff -u -p -r1.14 Boolean.java
--- libraries/javalib/java/lang/Boolean.java	24 Sep 2003 19:06:24 -0000	1.14
+++ libraries/javalib/java/lang/Boolean.java	5 Jan 2005 14:54:23 -0000
@@ -78,8 +78,7 @@ public final class Boolean implements Se
    *
    * @since 1.1
    */
-  /* Kaffe doesn't have VMClassLoader yet. */
-  public static final Class TYPE = Class.getPrimitiveClass("boolean");
+  public static final Class TYPE = VMClassLoader.getPrimitiveClass('Z');
 
   /**
    * The immutable value of this Boolean.
Index: libraries/javalib/java/lang/Byte.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Byte.java,v
retrieving revision 1.16
diff -u -p -r1.16 Byte.java
--- libraries/javalib/java/lang/Byte.java	20 Feb 2003 13:52:08 -0000	1.16
+++ libraries/javalib/java/lang/Byte.java	5 Jan 2005 14:54:23 -0000
@@ -15,7 +15,7 @@ public final class Byte extends Number i
 {
 	final public static byte MIN_VALUE = -0x80;
 	final public static byte MAX_VALUE = 0x7F;
-	final public static Class TYPE = Class.getPrimitiveClass("byte");
+	final public static Class TYPE = VMClassLoader.getPrimitiveClass('B');
 	final private byte value;
 
 	/* This is what Sun's JDK1.1 "serialver java.lang.Byte" spits out */
Index: libraries/javalib/java/lang/Character.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Character.java,v
retrieving revision 1.24
diff -u -p -r1.24 Character.java
--- libraries/javalib/java/lang/Character.java	24 Oct 2004 17:26:18 -0000	1.24
+++ libraries/javalib/java/lang/Character.java	5 Jan 2005 14:54:24 -0000
@@ -1031,7 +1031,7 @@ public final class Character implements 
    *
    * @since 1.1
    */
-  public static final Class TYPE = Class.getPrimitiveClass("char");
+  public static final Class TYPE = VMClassLoader.getPrimitiveClass('C');
 
   /**
    * Lu = Letter, Uppercase (Informative).
Index: libraries/javalib/java/lang/Class.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Class.java,v
retrieving revision 1.51
diff -u -p -r1.51 Class.java
--- libraries/javalib/java/lang/Class.java	21 Dec 2004 16:51:12 -0000	1.51
+++ libraries/javalib/java/lang/Class.java	5 Jan 2005 14:54:24 -0000
@@ -1,13 +1,40 @@
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
- * Portions Copyright (C) 1998, 2002, 2003 Free Software Foundation
- *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- */
+/* Class.java -- Representation of a Java class.
+   Copyright (C) 1998, 1999, 2000, 2002, 2003, 2004
+   Free Software Foundation
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
 package java.lang;
 
@@ -20,421 +47,1238 @@ import java.lang.reflect.Member;
 import java.lang.reflect.Method;
 import java.lang.reflect.Modifier;
 import java.net.URL;
+import java.security.AccessController;
+import java.security.AllPermission;
+import java.security.Permissions;
+import java.security.PrivilegedAction;
 import java.security.ProtectionDomain;
-import java.util.Vector;
-
-import kaffe.lang.PackageHelper;
-import kaffe.lang.PrimordialClassLoader;
-import kaffe.lang.ThreadStack;
-
-public final class Class implements Serializable {
-
-/* For GCJ compatibility, we cannot define any fields in
- * java.lang.Class at this point.  Valid as of 10/28/99
- * We special case it instead in clib/native/ObjectStreamClassImpl.c
- * --gback
- */
-// private static final long serialVersionUID = 3206093459760846163L;
-
-// Only instantiable by the VM
-private Class() {
-}
-
-public static Class forName(String className) throws ClassNotFoundException {
-	return forName(className, true, ThreadStack.getCallersClassLoader(false));
-}
-
-/*
- * NOTE: We go native here because it already implements all the necessary
- * synchronization stuff.
- */
-public static native Class forName(String className, boolean initialize, ClassLoader loader) throws ClassNotFoundException;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.HashSet;
 
-private String fullResourceName(String name) {
-	if (name.charAt(0) == '/') {
-		return name;
-	}
-	String cname = getName();
-	StringBuffer buf = new StringBuffer();
-	int tail = cname.lastIndexOf('.');
-	if (tail != -1) {
-		buf.append(cname.substring(0, tail+1).replace('.', '/'));
-	}
-	buf.append(name);
-	return (buf.toString());
-}
 
 /**
- * Determines the class loader for the class.
+ * A Class represents a Java type.  There will never be multiple Class
+ * objects with identical names and ClassLoaders. Primitive types, array
+ * types, and void also have a Class object.
  *
- * @returns   the class loader that created the class or interface
- *            represented by this object, or null if the class was not
- *            created by a class loader.
- * @see       java.lang.ClassLoader
- */
-public ClassLoader getClassLoader() {
-	return (getClassLoader0());
-}
-
-native private ClassLoader getClassLoader0();
-
-/**
- * If this is an inner class, return the class that
- * declared it.  If not, return null.
+ * <p>Arrays with identical type and number of dimensions share the same class.
+ * The array class ClassLoader is the same as the ClassLoader of the element
+ * type of the array (which can be null to indicate the bootstrap classloader).
+ * The name of an array class is <code>[&lt;signature format&gt;;</code>.
+ * <p> For example,
+ * String[]'s class is <code>[Ljava.lang.String;</code>. boolean, byte,
+ * short, char, int, long, float and double have the "type name" of
+ * Z,B,S,C,I,J,F,D for the purposes of array classes.  If it's a
+ * multidimensioned array, the same principle applies:
+ * <code>int[][][]</code> == <code>[[[I</code>.
  *
- * @return the declaring class of this class.
- * @since JDK1.1
- */
-public Class getDeclaringClass() {
-	Class[] classes = getClasses0(false);
-
-	switch (classes.length) {
-	case 0:
-		return null;
-	case 1:
-		return classes[0];
-	default:
-		throw new ClassFormatError ("Too many outer classes :" + classes.length);
-	}
-}
-
-/**
- * Get all the public inner classes, declared in this
- * class or inherited from superclasses, that are
- * members of this class.
+ * <p>There is no public constructor - Class objects are obtained only through
+ * the virtual machine, as defined in ClassLoaders.
  *
- * @return all public inner classes in this class.
- * @since JDK1.1
- */
-public Class[] getClasses() {
-	SecurityManager sm = System.getSecurityManager();
-	Vector v = new Vector();
-	Class clazz = this;
-	while (clazz != null) {
-		if (sm != null)
-			sm.checkMemberAccess(clazz, Member.PUBLIC);
-		Class[] classes = clazz.getClasses0(true);
-
-		for (int i = 0; i < classes.length; i++) {
-			if (Modifier.isPublic(classes[i].getModifiers())) {
-				v.add (classes[i]);
-			}
-		}
-		clazz = clazz.getSuperclass();
-	}
-
-	return (Class[])v.toArray (new Class[v.size()]);
-}
-
-native private Class[] getClasses0(boolean inner);
-
-native public Class getComponentType();
-
-public Constructor getConstructor(Class parameterTypes[]) throws NoSuchMethodException, SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.PUBLIC);
-	return (getConstructor0(parameterTypes, false));
-}
-
-native private Constructor getConstructor0(Class[] args, boolean declared);
-
-public Constructor[] getConstructors() throws SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.PUBLIC);
-	return (getConstructors0(false));
-}
-
-native private Constructor[] getConstructors0(boolean declared);
-
-/**
- * Get all the inner classes declared in this class.
+ * @serialData Class objects serialize specially:
+ * <code>TC_CLASS ClassDescriptor</code>. For more serialization information,
+ * see {@link ObjectStreamClass}.
  *
- * @return all inner classes declared in this class.
- * @exception SecurityException if you do not have access
- *            to non-public inner classes of this class.
- * @since JDK1.1
+ * @author John Keiser
+ * @author Eric Blake (ebb9@email.byu.edu)
+ * @author Tom Tromey (tromey@cygnus.com)
+ * @since 1.0
+ * @see ClassLoader
  */
-public Class[] getDeclaredClasses() throws SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.DECLARED);
-	return (getClasses0(true));
-}
-
-public Constructor getDeclaredConstructor(Class parameterTypes[]) throws NoSuchMethodException, SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.DECLARED);
-	return (getConstructor0(parameterTypes, true));
-}
-
-public Constructor[] getDeclaredConstructors() throws SecurityException
+public final class Class implements Serializable
 {
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.DECLARED);
-	return (getConstructors0(true));
-}
-
-public Field getDeclaredField(String name) throws NoSuchFieldException, SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.DECLARED);
+  /**
+   * Compatible with JDK 1.0+.
+   */
+  private static final long serialVersionUID = 3206093459760846163L;
 
-	return getFieldInternal(name, true);
-}
+  /** The class signers. */
+  private Object[] signers = null;
+  /** The class protection domain. */
+  private final ProtectionDomain pd;
 
-public Field[] getDeclaredFields() throws SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.DECLARED);
-	return (getFields0(true));
-}
+  /* We use an inner class, so that Class doesn't have a static initializer */
+  private static final class StaticData
+  {
+    static final ProtectionDomain unknownProtectionDomain;
 
-public Method getDeclaredMethod(String name, Class parameterTypes[]) throws NoSuchMethodException, SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.DECLARED);
+    static
+    {
+      Permissions permissions = new Permissions();
+      permissions.add(new AllPermission());
+      unknownProtectionDomain = new ProtectionDomain(null, permissions);
+    }
+  }
 
-	return lookupMethod(name, parameterTypes, true);
-}
+  final transient Object vmdata;
 
-public Method[] getDeclaredMethods() throws SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.DECLARED);
-	return (getMethods0(true));
-}
+  /** newInstance() caches the default constructor */
+  private transient Constructor constructor;
 
-public Field getField(String name) throws NoSuchFieldException, SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.PUBLIC);
+  /**
+   * Class is non-instantiable from Java code; only the VM can create
+   * instances of this class.
+   */
+  Class(Object vmdata)
+  {
+    this(vmdata, null);
+  }
 
-	return getFieldInternal(name, false);
-}
+  Class(Object vmdata, ProtectionDomain pd)
+  {
+    this.vmdata = vmdata;
+    this.pd = pd;
+  }
 
-/* Lookup a field in a class.
+  /**
+   * Use the classloader of the current class to load, link, and initialize
+   * a class. This is equivalent to your code calling
+   * <code>Class.forName(name, true, getClass().getClassLoader())</code>.
+   *
+   * @param name the name of the class to find
+   * @return the Class object representing the class
+   * @throws ClassNotFoundException if the class was not found by the
+   *         classloader
+   * @throws LinkageError if linking the class fails
+   * @throws ExceptionInInitializerError if the class loads, but an exception
+   *         occurs during initialization
+   */
+  public static Class forName(String name) throws ClassNotFoundException
+  {
+    Class result = VMClass.forName (name);
+    if (result == null)
+      result = Class.forName(name, true,
+			     VMSecurityManager.getClassContext()[0].getClassLoader());
+    return result;
+  }
 
-   @param name a field name
-   @param declared true if the field is supposed to be declared in this class
+  /**
+   * Use the specified classloader to load and link a class. If the loader
+   * is null, this uses the bootstrap class loader (provide the security
+   * check succeeds). Unfortunately, this method cannot be used to obtain
+   * the Class objects for primitive types or for void, you have to use
+   * the fields in the appropriate java.lang wrapper classes.
+   *
+   * <p>Calls <code>classloader.loadclass(name, initialize)</code>.
+   *
+   * @param name the name of the class to find
+   * @param initialize whether or not to initialize the class at this time
+   * @param classloader the classloader to use to find the class; null means
+   *        to use the bootstrap class loader
+   *
+   * @return the class object for the given class
+   *
+   * @throws ClassNotFoundException if the class was not found by the
+   *         classloader
+   * @throws LinkageError if linking the class fails
+   * @throws ExceptionInInitializerError if the class loads, but an exception
+   *         occurs during initialization
+   * @throws SecurityException if the <code>classloader</code> argument
+   *         is <code>null</code> and the caller does not have the
+   *         <code>RuntimePermission("getClassLoader")</code> permission
+   * @see ClassLoader
+   * @since 1.2
+   */
+  public static Class forName(String name, boolean initialize,
+                              ClassLoader classloader)
+    throws ClassNotFoundException
+  {
+    if (classloader == null)
+      {
+        // Check if we may access the bootstrap classloader
+        SecurityManager sm = SecurityManager.current;
+        if (sm != null)
+          {
+            // Get the calling class and classloader
+            Class c = VMSecurityManager.getClassContext()[0];
+            ClassLoader cl = c.getClassLoader();
+            if (cl != null)
+              sm.checkPermission(new RuntimePermission("getClassLoader"));
+          }
+	if (name.startsWith("["))
+	  return VMClass.loadArrayClass(name, null);
+	Class c = VMClassLoader.loadClass(name, true);
+	if (c != null)
+	  {
+	    if (initialize)
+	      VMClass.initialize(c);
+	    return c;
+	  }
+        throw new ClassNotFoundException(name);
+      }
+    if (name.startsWith("["))
+      return VMClass.loadArrayClass(name, classloader);
+    Class c = classloader.loadClass(name);
+    classloader.resolveClass(c);
+    if (initialize)
+      VMClass.initialize(c);
+    return c;
+  }
+  
+  /**
+   * Get all the public member classes and interfaces declared in this
+   * class or inherited from superclasses. This returns an array of length
+   * 0 if there are no member classes, including for primitive types. A
+   * security check may be performed, with
+   * <code>checkMemberAccess(this, Member.PUBLIC)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @return all public member classes in this class
+   * @throws SecurityException if the security check fails
+   * @since 1.1
+   */
+  public Class[] getClasses()
+  {
+    memberAccessCheck(Member.PUBLIC);
+    return internalGetClasses();
+  }
 
-   @return a pointer to the field, if it can be found.
+  /**
+   * Like <code>getClasses()</code> but without the security checks.
+   */
+  private Class[] internalGetClasses()
+  {
+    ArrayList list = new ArrayList();
+    list.addAll(Arrays.asList(getDeclaredClasses(true)));
+    Class superClass = getSuperclass();
+    if (superClass != null)
+      list.addAll(Arrays.asList(superClass.internalGetClasses()));
+    return (Class[])list.toArray(new Class[list.size()]);
+  }
+  
+  /**
+   * Get the ClassLoader that loaded this class.  If the class was loaded
+   * by the bootstrap classloader, this method will return null.
+   * If there is a security manager, and the caller's class loader is not
+   * an ancestor of the requested one, a security check of
+   * <code>RuntimePermission("getClassLoader")</code>
+   * must first succeed. Primitive types and void return null.
+   *
+   * @return the ClassLoader that loaded this class
+   * @throws SecurityException if the security check fails
+   * @see ClassLoader
+   * @see RuntimePermission
+   */
+  public ClassLoader getClassLoader()
+  {
+    if (isPrimitive())
+      return null;
 
-   @throws NoSuchFieldException if no such field can be found
-*/
-private Field getFieldInternal(String name, boolean declared) throws NoSuchFieldException {
-	Field field = getField0(name, declared);
+    ClassLoader loader = VMClass.getClassLoader(this);
+    // Check if we may get the classloader
+    SecurityManager sm = SecurityManager.current;
+    if (sm != null)
+      {
+        // Get the calling class and classloader
+        Class c = VMSecurityManager.getClassContext()[0];
+        ClassLoader cl = VMClass.getClassLoader(c);
+        if (cl != null && !cl.isAncestorOf(loader))
+          sm.checkPermission(new RuntimePermission("getClassLoader"));
+      }
+    return loader;
+  }
 
-        if (field == null) {
-		throw new NoSuchFieldException("Class " + getName() + " has no field named " + name);
-	}
+  /**
+   * If this is an array, get the Class representing the type of array.
+   * Examples: "[[Ljava.lang.String;" would return "[Ljava.lang.String;", and
+   * calling getComponentType on that would give "java.lang.String".  If
+   * this is not an array, returns null.
+   *
+   * @return the array type of this class, or null
+   * @see Array
+   * @since 1.1
+   */
+  public Class getComponentType()
+  {
+    return VMClass.getComponentType (this);
+  }
 
-        return field;
-}
+  /**
+   * Get a public constructor declared in this class. If the constructor takes
+   * no argument, an array of zero elements and null are equivalent for the
+   * types argument. A security check may be performed, with
+   * <code>checkMemberAccess(this, Member.PUBLIC)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @param types the type of each parameter
+   * @return the constructor
+   * @throws NoSuchMethodException if the constructor does not exist
+   * @throws SecurityException if the security check fails
+   * @see #getConstructors()
+   * @since 1.1
+   */
+  public Constructor getConstructor(Class[] types) throws NoSuchMethodException
+  {
+    memberAccessCheck(Member.PUBLIC);
+    Constructor[] constructors = getDeclaredConstructors(true);
+    for (int i = 0; i < constructors.length; i++)
+      {
+	Constructor constructor = constructors[i];
+	if (matchParameters(types, constructor.getParameterTypes()))
+	  return constructor;
+      }
+    throw new NoSuchMethodException();
+  }
 
-native private Field getField0(String name, boolean declared);
+  /**
+   * Get all the public constructors of this class. This returns an array of
+   * length 0 if there are no constructors, including for primitive types,
+   * arrays, and interfaces. It does, however, include the default
+   * constructor if one was supplied by the compiler. A security check may
+   * be performed, with <code>checkMemberAccess(this, Member.PUBLIC)</code>
+   * as well as <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @return all public constructors in this class
+   * @throws SecurityException if the security check fails
+   * @since 1.1
+   */
+  public Constructor[] getConstructors()
+  {
+    memberAccessCheck(Member.PUBLIC);
+    return getDeclaredConstructors(true);
+  }
 
-public Field[] getFields() throws SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.PUBLIC);
-	return (getFields0(false));
-}
+  /**
+   * Get a constructor declared in this class. If the constructor takes no
+   * argument, an array of zero elements and null are equivalent for the
+   * types argument. A security check may be performed, with
+   * <code>checkMemberAccess(this, Member.DECLARED)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @param types the type of each parameter
+   * @return the constructor
+   * @throws NoSuchMethodException if the constructor does not exist
+   * @throws SecurityException if the security check fails
+   * @see #getDeclaredConstructors()
+   * @since 1.1
+   */
+  public Constructor getDeclaredConstructor(Class[] types)
+    throws NoSuchMethodException
+  {
+    memberAccessCheck(Member.DECLARED);
+    Constructor[] constructors = getDeclaredConstructors(false);
+    for (int i = 0; i < constructors.length; i++)
+      {
+	Constructor constructor = constructors[i];
+	if (matchParameters(types, constructor.getParameterTypes()))
+	  return constructor;
+      }
+    throw new NoSuchMethodException();
+  }
 
-native private Field[] getFields0(boolean declared);
+  /**
+   * Get all the declared member classes and interfaces in this class, but
+   * not those inherited from superclasses. This returns an array of length
+   * 0 if there are no member classes, including for primitive types. A
+   * security check may be performed, with
+   * <code>checkMemberAccess(this, Member.DECLARED)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @return all declared member classes in this class
+   * @throws SecurityException if the security check fails
+   * @since 1.1
+   */
+  public Class[] getDeclaredClasses()
+  {
+    memberAccessCheck(Member.DECLARED);
+    return getDeclaredClasses(false);
+  }
 
-native public Class[] getInterfaces();
+  Class[] getDeclaredClasses (boolean publicOnly)
+  {
+    return VMClass.getDeclaredClasses (this, publicOnly);
+  }
 
-public Method getMethod(String name, Class parameterTypes[]) throws NoSuchMethodException, SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.PUBLIC );
-	if( name.equals("<init>") || name.equals("<clinit>") )
-		throw new NoSuchMethodException();
-	return (lookupMethod(name, parameterTypes, false));
-}
+  /**
+   * Get all the declared constructors of this class. This returns an array of
+   * length 0 if there are no constructors, including for primitive types,
+   * arrays, and interfaces. It does, however, include the default
+   * constructor if one was supplied by the compiler. A security check may
+   * be performed, with <code>checkMemberAccess(this, Member.DECLARED)</code>
+   * as well as <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @return all constructors in this class
+   * @throws SecurityException if the security check fails
+   * @since 1.1
+   */
+  public Constructor[] getDeclaredConstructors()
+  {
+    memberAccessCheck(Member.DECLARED);
+    return getDeclaredConstructors(false);
+  }
 
-native private Method getMethod0(String name, Class[] args, boolean declared);
+  Constructor[] getDeclaredConstructors (boolean publicOnly)
+  {
+    return VMClass.getDeclaredConstructors (this, publicOnly);
+  }
+  
+  /**
+   * Get a field declared in this class, where name is its simple name. The
+   * implicit length field of arrays is not available. A security check may
+   * be performed, with <code>checkMemberAccess(this, Member.DECLARED)</code>
+   * as well as <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @param name the name of the field
+   * @return the field
+   * @throws NoSuchFieldException if the field does not exist
+   * @throws SecurityException if the security check fails
+   * @see #getDeclaredFields()
+   * @since 1.1
+   */
+  public Field getDeclaredField(String name) throws NoSuchFieldException
+  {
+    memberAccessCheck(Member.DECLARED);
+    Field[] fields = getDeclaredFields(false);
+    for (int i = 0; i < fields.length; i++)
+      {
+	if (fields[i].getName().equals(name))
+	  return fields[i];
+      }
+    throw new NoSuchFieldException();
+  }
 
-public Method[] getMethods() throws SecurityException
-{
-	SecurityManager sm = System.getSecurityManager();
-	if (sm != null)
-		sm.checkMemberAccess(this, Member.PUBLIC);
-	return (getMethods0(false));
-}
+  /**
+   * Get all the declared fields in this class, but not those inherited from
+   * superclasses. This returns an array of length 0 if there are no fields,
+   * including for primitive types. This does not return the implicit length
+   * field of arrays. A security check may be performed, with
+   * <code>checkMemberAccess(this, Member.DECLARED)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @return all declared fields in this class
+   * @throws SecurityException if the security check fails
+   * @since 1.1
+   */
+  public Field[] getDeclaredFields()
+  {
+    memberAccessCheck(Member.DECLARED);
+    return getDeclaredFields(false);
+  }
 
-native private Method[] getMethods0(boolean declared);
+  Field[] getDeclaredFields (boolean publicOnly)
+  {
+    return VMClass.getDeclaredFields (this, publicOnly);
+  }
 
-native public int getModifiers();
+  /**
+   * Get a method declared in this class, where name is its simple name. The
+   * implicit methods of Object are not available from arrays or interfaces.
+   * Constructors (named "&lt;init&gt;" in the class file) and class initializers
+   * (name "&lt;clinit&gt;") are not available.  The Virtual Machine allows
+   * multiple methods with the same signature but differing return types; in
+   * such a case the most specific return types are favored, then the final
+   * choice is arbitrary. If the method takes no argument, an array of zero
+   * elements and null are equivalent for the types argument. A security
+   * check may be performed, with
+   * <code>checkMemberAccess(this, Member.DECLARED)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @param methodName the name of the method
+   * @param types the type of each parameter
+   * @return the method
+   * @throws NoSuchMethodException if the method does not exist
+   * @throws SecurityException if the security check fails
+   * @see #getDeclaredMethods()
+   * @since 1.1
+   */
+  public Method getDeclaredMethod(String methodName, Class[] types)
+    throws NoSuchMethodException
+  {
+    memberAccessCheck(Member.DECLARED);
+    Method match = matchMethod(getDeclaredMethods(false), methodName, types);
+    if (match == null)
+      throw new NoSuchMethodException(methodName);
+    return match;
+  }
 
-native public String getName();
+  /**
+   * Get all the declared methods in this class, but not those inherited from
+   * superclasses. This returns an array of length 0 if there are no methods,
+   * including for primitive types. This does include the implicit methods of
+   * arrays and interfaces which mirror methods of Object, nor does it
+   * include constructors or the class initialization methods. The Virtual
+   * Machine allows multiple methods with the same signature but differing
+   * return types; all such methods are in the returned array. A security
+   * check may be performed, with
+   * <code>checkMemberAccess(this, Member.DECLARED)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @return all declared methods in this class
+   * @throws SecurityException if the security check fails
+   * @since 1.1
+   */
+  public Method[] getDeclaredMethods()
+  {
+    memberAccessCheck(Member.DECLARED);
+    return getDeclaredMethods(false);
+  }
 
-public Package getPackage() {
-	ClassLoader loader = getClassLoader();
+  Method[] getDeclaredMethods (boolean publicOnly)
+  {
+    return VMClass.getDeclaredMethods (this, publicOnly);
+  }
+ 
+  /**
+   * If this is a nested or inner class, return the class that declared it.
+   * If not, return null.
+   *
+   * @return the declaring class of this class
+   * @since 1.1
+   */
+  public Class getDeclaringClass()
+  {
+    return VMClass.getDeclaringClass (this);
+  }
 
-	if (loader == null) {
-		return PrimordialClassLoader.getSingleton().
-				getPackage(PackageHelper.getPackageName(this));
-	}
+  /**
+   * Get a public field declared or inherited in this class, where name is
+   * its simple name. If the class contains multiple accessible fields by
+   * that name, an arbitrary one is returned. The implicit length field of
+   * arrays is not available. A security check may be performed, with
+   * <code>checkMemberAccess(this, Member.PUBLIC)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @param fieldName the name of the field
+   * @return the field
+   * @throws NoSuchFieldException if the field does not exist
+   * @throws SecurityException if the security check fails
+   * @see #getFields()
+   * @since 1.1
+   */
+  public Field getField(String fieldName)
+    throws NoSuchFieldException
+  {
+    memberAccessCheck(Member.PUBLIC);
+    Field field = internalGetField(fieldName);
+    if (field == null)
+      throw new NoSuchFieldException(fieldName);
+    return field;
+  }
 
-	return loader.getPackage(PackageHelper.getPackageName(this));
-}
+  /**
+   * Get all the public fields declared in this class or inherited from
+   * superclasses. This returns an array of length 0 if there are no fields,
+   * including for primitive types. This does not return the implicit length
+   * field of arrays. A security check may be performed, with
+   * <code>checkMemberAccess(this, Member.PUBLIC)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @return all public fields in this class
+   * @throws SecurityException if the security check fails
+   * @since 1.1
+   */
+  public Field[] getFields()
+  {
+    memberAccessCheck(Member.PUBLIC);
+    return internalGetFields();
+  }
 
-native public ProtectionDomain getProtectionDomain();
+  /**
+   * Like <code>getFields()</code> but without the security checks.
+   */
+  private Field[] internalGetFields()
+  {
+    HashSet set = new HashSet();
+    set.addAll(Arrays.asList(getDeclaredFields(true)));
+    Class[] interfaces = getInterfaces();
+    for (int i = 0; i < interfaces.length; i++)
+      set.addAll(Arrays.asList(interfaces[i].internalGetFields()));
+    Class superClass = getSuperclass();
+    if (superClass != null)
+      set.addAll(Arrays.asList(superClass.internalGetFields()));
+    return (Field[])set.toArray(new Field[set.size()]);
+  }
 
-native static Class getPrimitiveClass(String name);
+  /**
+   * Returns the <code>Package</code> in which this class is defined
+   * Returns null when this information is not available from the
+   * classloader of this class or when the classloader of this class
+   * is null.
+   *
+   * @return the package for this class, if it is available
+   * @since 1.2
+   */
+  public Package getPackage()
+  {
+    ClassLoader cl = getClassLoader();
+    if (cl != null)
+      return cl.getPackage(getPackagePortion(getName()));
+    return null;
+  }
 
-/**
- * Finds a resource with the specified name.
- * The rules for searching for resources associated with a given class
- * are implemented by the class loader of the class.
- * <p>
- * The Class methods delegate to ClassLoader methods, after applying a
- * naming convention: if the resource name starts with "/", it is used as
- * is. Otherwise, the name of the package is prepended, after converting
- * "." to "/".
- *
- * @param 	name the string representing the resource to be found.
- * @return 	the URL object having the specified name, or null if no
- * resource with the specified name is found.  */
-public URL getResource(String name) {
-	ClassLoader loader = getClassLoader();
-	name = fullResourceName(name);
+  /**
+   * Get the interfaces this class <em>directly</em> implements, in the
+   * order that they were declared. This returns an empty array, not null,
+   * for Object, primitives, void, and classes or interfaces with no direct
+   * superinterface. Array types return Cloneable and Serializable.
+   *
+   * @return the interfaces this class directly implements
+   */
+  public Class[] getInterfaces()
+  {
+    return VMClass.getInterfaces (this);
+  }
 
-	if (loader == null) {
-		return ClassLoader.getSystemResource(name);
+  private static final class MethodKey
+  {
+    private String name;
+    private Class[] params;
+    private Class returnType;
+    private int hash;
+    
+    MethodKey(Method m)
+    {
+      name = m.getName();
+      params = m.getParameterTypes();
+      returnType = m.getReturnType();
+      hash = name.hashCode() ^ returnType.hashCode();
+      for(int i = 0; i < params.length; i++)
+	{
+	  hash ^= params[i].hashCode();
 	}
-	return (loader.getResource(name));
-}
-
-/**
- * Finds a resource with a given name.
- * Will return null if no resource with this name is found. The rules
- * for searching a resources associated with a given class are implemented
- * by the ClassLoader of the class.
- *
- * The Class methods delegate to ClassLoader methods, after applying a
- * naming convention: if the resource name starts with "/", it is used
- * as is. Otherwise, the name of the package is prepended, after
- * converting "." to "/".
- *
- * @param 	name the string representing the resource to be found
- * @return 	the InputStream object having the specified name, or null
- *		if no resource with the specified name is found.
- */
-public InputStream getResourceAsStream(String name) {
-  	ClassLoader loader = getClassLoader();
-	name = fullResourceName (name);
-
-	if (loader == null) {
-		return ClassLoader.getSystemResourceAsStream(name);
+    }
+    
+    public boolean equals(Object o)
+    {
+      if(o instanceof MethodKey)
+	{
+	  MethodKey m = (MethodKey)o;
+	  if(m.name.equals(name) && m.params.length == params.length && m.returnType == returnType)
+	    {
+	      for(int i = 0; i < params.length; i++)
+		{
+		  if(m.params[i] != params[i])
+		    {
+		      return false;
+		    }
+		}
+	      return true;
+	    }
 	}
-	
-	return loader.getResourceAsStream(name);
-}
+      return false;
+    }
+    
+    public int hashCode()
+    {
+      return hash;
+    }
+  }
+  
+  /**
+   * Get a public method declared or inherited in this class, where name is
+   * its simple name. The implicit methods of Object are not available from
+   * interfaces.  Constructors (named "&lt;init&gt;" in the class file) and class
+   * initializers (name "&lt;clinit&gt;") are not available.  The Virtual
+   * Machine allows multiple methods with the same signature but differing
+   * return types, and the class can inherit multiple methods of the same
+   * return type; in such a case the most specific return types are favored,
+   * then the final choice is arbitrary. If the method takes no argument, an
+   * array of zero elements and null are equivalent for the types argument.
+   * A security check may be performed, with
+   * <code>checkMemberAccess(this, Member.PUBLIC)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @param methodName the name of the method
+   * @param types the type of each parameter
+   * @return the method
+   * @throws NoSuchMethodException if the method does not exist
+   * @throws SecurityException if the security check fails
+   * @see #getMethods()
+   * @since 1.1
+   */
+  public Method getMethod(String methodName, Class[] types)
+    throws NoSuchMethodException
+  {
+    memberAccessCheck(Member.PUBLIC);
+    Method method = internalGetMethod(methodName, types);
+    if (method == null)
+      throw new NoSuchMethodException(methodName);
+    return method;
+  }
 
-public Object[] getSigners()
-{
-        Object[] signers = getSigners0();
-        return signers == null ? null : (Object[]) signers.clone();
-}
+  /**
+   * Like <code>getMethod(String,Class[])</code> but without the security
+   * checks and returns null instead of throwing NoSuchMethodException.
+   */
+  private Method internalGetMethod(String methodName, Class[] args)
+  {
+    Method match = matchMethod(getDeclaredMethods(true), methodName, args);
+    if (match != null)
+      return match;
+    Class superClass = getSuperclass();
+    if (superClass != null)
+      {
+	match = superClass.internalGetMethod(methodName, args);
+	if(match != null)
+	  return match;
+      }
+    Class[] interfaces = getInterfaces();
+    for (int i = 0; i < interfaces.length; i++)
+      {
+	match = interfaces[i].internalGetMethod(methodName, args);
+	if (match != null)
+	  return match;
+      }
+    return null;
+  }
 
-private native Object[] getSigners0();
+  /** 
+   * Find the best matching method in <code>list</code> according to
+   * the definition of ``best matching'' used by <code>getMethod()</code>
+   *
+   * <p>
+   * Returns the method if any, otherwise <code>null</code>.
+   *
+   * @param list List of methods to search
+   * @param name Name of method
+   * @param args Method parameter types
+   * @see #getMethod()
+   */
+  private static Method matchMethod(Method[] list, String name, Class[] args)
+  {
+    Method match = null;
+    for (int i = 0; i < list.length; i++)
+      {
+	Method method = list[i];
+	if (!method.getName().equals(name))
+	  continue;
+	if (!matchParameters(args, method.getParameterTypes()))
+	  continue;
+	if (match == null
+	    || match.getReturnType().isAssignableFrom(method.getReturnType()))
+	  match = method;
+      }
+    return match;
+  }
 
-native void setSigners(Object[] signers);
+  /**
+   * Check for an exact match between parameter type lists.
+   * Either list may be <code>null</code> to mean a list of
+   * length zero.
+   */
+  private static boolean matchParameters(Class[] types1, Class[] types2)
+  {
+    if (types1 == null)
+      return types2 == null || types2.length == 0;
+    if (types2 == null)
+      return types1 == null || types1.length == 0;
+    if (types1.length != types2.length)
+      return false;
+    for (int i = 0; i < types1.length; i++)
+      {
+	if (types1[i] != types2[i])
+	  return false;
+      }
+    return true;
+  }
+  
+  /**
+   * Get all the public methods declared in this class or inherited from
+   * superclasses. This returns an array of length 0 if there are no methods,
+   * including for primitive types. This does not include the implicit
+   * methods of interfaces which mirror methods of Object, nor does it
+   * include constructors or the class initialization methods. The Virtual
+   * Machine allows multiple methods with the same signature but differing
+   * return types; all such methods are in the returned array. A security
+   * check may be performed, with
+   * <code>checkMemberAccess(this, Member.PUBLIC)</code> as well as
+   * <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @return all public methods in this class
+   * @throws SecurityException if the security check fails
+   * @since 1.1
+   */
+  public Method[] getMethods()
+  {
+    memberAccessCheck(Member.PUBLIC);
+    // NOTE the API docs claim that no methods are returned for arrays,
+    // but Sun's implementation *does* return the public methods of Object
+    // (as would be expected), so we follow their implementation instead
+    // of their documentation.
+    return internalGetMethods();
+  }
 
-native public Class getSuperclass();
+  /**
+   * Like <code>getMethods()</code> but without the security checks.
+   */
+  private Method[] internalGetMethods()
+  {
+    HashMap map = new HashMap();
+    Method[] methods;
+    Class[] interfaces = getInterfaces();
+    for(int i = 0; i < interfaces.length; i++)
+      {
+	methods = interfaces[i].internalGetMethods();
+	for(int j = 0; j < methods.length; j++)
+	  {
+	    map.put(new MethodKey(methods[j]), methods[j]);
+	  }
+      }
+    Class superClass = getSuperclass();
+    if(superClass != null)
+      {
+	methods = superClass.internalGetMethods();
+	for(int i = 0; i < methods.length; i++)
+	  {
+	    map.put(new MethodKey(methods[i]), methods[i]);
+	  }
+      }
+    methods = getDeclaredMethods(true);
+    for(int i = 0; i < methods.length; i++)
+      {
+	map.put(new MethodKey(methods[i]), methods[i]);
+      }
+    return (Method[])map.values().toArray(new Method[map.size()]);
+  }
 
-native public boolean isArray();
+  /**
+   * Get the modifiers of this class.  These can be decoded using Modifier,
+   * and is limited to one of public, protected, or private, and any of
+   * final, static, abstract, or interface. An array class has the same
+   * public, protected, or private modifier as its component type, and is
+   * marked final but not an interface. Primitive types and void are marked
+   * public and final, but not an interface.
+   *
+   * @return the modifiers of this class
+   * @see Modifer
+   * @since 1.1
+   */
+  public int getModifiers()
+  {
+    return VMClass.getModifiers (this);
+  }
+  
+  /**
+   * Get the name of this class, separated by dots for package separators.
+   * If the class represents a primitive type, or void, then the
+   * name of the type as it appears in the Java programming language
+   * is returned.  For instance, <code>Byte.TYPE.getName()</code>
+   * returns "byte".
+   *
+   * Arrays are specially encoded as shown on this table.
+   * <pre>
+   * array type          [<em>element type</em>
+   *                     (note that the element type is encoded per
+   *                      this table)
+   * boolean             Z
+   * byte                B
+   * char                C
+   * short               S
+   * int                 I
+   * long                J
+   * float               F
+   * double              D
+   * void                V
+   * class or interface, alone: &lt;dotted name&gt;
+   * class or interface, as element type: L&lt;dotted name&gt;;
+   * </pre>
+   *
+   * @return the name of this class
+   */
+  public String getName()
+  { 
+    return VMClass.getName (this);
+  }
 
-native public boolean isAssignableFrom(Class cls);
+  /**
+   * Get a resource URL using this class's package using the
+   * getClassLoader().getResource() method.  If this class was loaded using
+   * the system classloader, ClassLoader.getSystemResource() is used instead.
+   *
+   * <p>If the name you supply is absolute (it starts with a <code>/</code>),
+   * then the leading <code>/</code> is removed and it is passed on to
+   * getResource(). If it is relative, the package name is prepended, and
+   * <code>.</code>'s are replaced with <code>/</code>.
+   *
+   * <p>The URL returned is system- and classloader-dependent, and could
+   * change across implementations.
+   *
+   * @param resourceName the name of the resource, generally a path
+   * @return the URL to the resource
+   * @throws NullPointerException if name is null
+   * @since 1.1
+   */
+  public URL getResource(String resourceName)
+  {
+    String name = resourcePath(resourceName);
+    ClassLoader loader = getClassLoader();
+    if (loader == null)
+      return ClassLoader.getSystemResource(name);
+    return loader.getResource(name);
+  }
 
-native public boolean isInstance(Object obj);
+  /**
+   * Get a resource using this class's package using the
+   * getClassLoader().getResourceAsStream() method.  If this class was loaded
+   * using the system classloader, ClassLoader.getSystemResource() is used
+   * instead.
+   *
+   * <p>If the name you supply is absolute (it starts with a <code>/</code>),
+   * then the leading <code>/</code> is removed and it is passed on to
+   * getResource(). If it is relative, the package name is prepended, and
+   * <code>.</code>'s are replaced with <code>/</code>.
+   *
+   * <p>The URL returned is system- and classloader-dependent, and could
+   * change across implementations.
+   *
+   * @param resourceName the name of the resource, generally a path
+   * @return an InputStream with the contents of the resource in it, or null
+   * @throws NullPointerException if name is null
+   * @since 1.1
+   */
+  public InputStream getResourceAsStream(String resourceName)
+  {
+    String name = resourcePath(resourceName);
+    ClassLoader loader = getClassLoader();
+    if (loader == null)
+      return ClassLoader.getSystemResourceAsStream(name);
+    return loader.getResourceAsStream(name);
+  }
+
+  private String resourcePath(String resourceName)
+  {
+    if (resourceName.length() > 0)
+    {
+      if (resourceName.charAt(0) != '/')
+      {
+        String pkg = getPackagePortion(getName());
+        if (pkg.length() > 0)
+          resourceName = pkg.replace('.','/') + '/' + resourceName;
+      }
+      else
+      {
+        resourceName = resourceName.substring(1);
+      }
+    }
+    return resourceName;
+  }
 
-native public boolean isInterface();
+  /**
+   * Get the signers of this class. This returns null if there are no signers,
+   * such as for primitive types or void.
+   *
+   * @return the signers of this class
+   * @since 1.1
+   */
+  public Object[] getSigners()
+  {
+    return signers == null ? null : (Object[]) signers.clone ();
+  }
+  
+  /**
+   * Set the signers of this class.
+   *
+   * @param signers the signers of this class
+   */
+  void setSigners(Object[] signers)
+  {
+    this.signers = signers;
+  }
 
-native public boolean isPrimitive();
+  /**
+   * Get the direct superclass of this class.  If this is an interface,
+   * Object, a primitive type, or void, it will return null. If this is an
+   * array type, it will return Object.
+   *
+   * @return the direct superclass of this class
+   */
+  public Class getSuperclass()
+  {
+    return VMClass.getSuperclass (this);
+  }
+  
+  /**
+   * Return whether this class is an array type.
+   *
+   * @return whether this class is an array type
+   * @since 1.1
+   */
+  public boolean isArray()
+  {
+    return VMClass.isArray (this);
+  }
+  
+  /**
+   * Discover whether an instance of the Class parameter would be an
+   * instance of this Class as well.  Think of doing
+   * <code>isInstance(c.newInstance())</code> or even
+   * <code>c.newInstance() instanceof (this class)</code>. While this
+   * checks widening conversions for objects, it must be exact for primitive
+   * types.
+   *
+   * @param c the class to check
+   * @return whether an instance of c would be an instance of this class
+   *         as well
+   * @throws NullPointerException if c is null
+   * @since 1.1
+   */
+  public boolean isAssignableFrom(Class c)
+  {
+    return VMClass.isAssignableFrom (this, c);
+  }
+ 
+  /**
+   * Discover whether an Object is an instance of this Class.  Think of it
+   * as almost like <code>o instanceof (this class)</code>.
+   *
+   * @param o the Object to check
+   * @return whether o is an instance of this class
+   * @since 1.1
+   */
+  public boolean isInstance(Object o)
+  {
+    return VMClass.isInstance (this, o);
+  }
+  
+  /**
+   * Check whether this class is an interface or not.  Array types are not
+   * interfaces.
+   *
+   * @return whether this class is an interface or not
+   */
+  public boolean isInterface()
+  {
+    return VMClass.isInterface (this);
+  }
+  
+  /**
+   * Return whether this class is a primitive type.  A primitive type class
+   * is a class representing a kind of "placeholder" for the various
+   * primitive types, or void.  You can access the various primitive type
+   * classes through java.lang.Boolean.TYPE, java.lang.Integer.TYPE, etc.,
+   * or through boolean.class, int.class, etc.
+   *
+   * @return whether this class is a primitive type
+   * @see Boolean#TYPE
+   * @see Byte#TYPE
+   * @see Character#TYPE
+   * @see Short#TYPE
+   * @see Integer#TYPE
+   * @see Long#TYPE
+   * @see Float#TYPE
+   * @see Double#TYPE
+   * @see Void#TYPE
+   * @since 1.1
+   */
+  public boolean isPrimitive()
+  {
+    return VMClass.isPrimitive (this);
+  }
+  
+  /**
+   * Get a new instance of this class by calling the no-argument constructor.
+   * The class is initialized if it has not been already. A security check
+   * may be performed, with <code>checkMemberAccess(this, Member.PUBLIC)</code>
+   * as well as <code>checkPackageAccess</code> both having to succeed.
+   *
+   * @return a new instance of this class
+   * @throws InstantiationException if there is not a no-arg constructor
+   *         for this class, including interfaces, abstract classes, arrays,
+   *         primitive types, and void; or if an exception occurred during
+   *         the constructor
+   * @throws IllegalAccessException if you are not allowed to access the
+   *         no-arg constructor because of scoping reasons
+   * @throws SecurityException if the security check fails
+   * @throws ExceptionInInitializerError if class initialization caused by
+   *         this call fails with an exception
+   */
+  public Object newInstance()
+    throws InstantiationException, IllegalAccessException
+  {
+    memberAccessCheck(Member.PUBLIC);
+    Constructor constructor;
+    synchronized(this)
+      {
+	constructor = this.constructor;
+      }
+    if (constructor == null)
+      {
+	Constructor[] constructors = getDeclaredConstructors(false);
+	for (int i = 0; i < constructors.length; i++)
+	  {
+	    if (constructors[i].getParameterTypes().length == 0)
+	      {
+		constructor = constructors[i];
+		break;
+	      }
+	  }
+	if (constructor == null)
+	  throw new InstantiationException(getName());
+	if (!Modifier.isPublic(constructor.getModifiers()))
+	  {
+	    final Constructor finalConstructor = constructor;
+	    AccessController.doPrivileged(new PrivilegedAction() {
+		public Object run() {
+		  finalConstructor.setAccessible(true);
+		  return null;
+		}
+	      });
+	  }
+	synchronized(this)
+	  {
+	    if (this.constructor == null)
+	      this.constructor = constructor;
+	  }	    
+      }
+    int modifiers = constructor.getModifiers();
+    if (!Modifier.isPublic(modifiers))
+      {
+	Class caller = VMSecurityManager.getClassContext()[0];
+	if (caller != this &&
+	    (Modifier.isPrivate(modifiers)
+	     || getClassLoader() != caller.getClassLoader()
+	     || !getPackagePortion(getName())
+	     .equals(getPackagePortion(caller.getName()))))
+	  throw new IllegalAccessException(getName()
+					   + " has an inaccessible constructor");
+      }
+    try
+      {
+        return constructor.newInstance(null);
+      }
+    catch (InvocationTargetException e)
+      {
+	VMClass.throwException(e.getTargetException());
+	throw (InternalError) new InternalError
+	  ("VMClass.throwException returned").initCause(e);
+      }
+  }
 
+  /**
+   * Returns the protection domain of this class. If the classloader did not
+   * record the protection domain when creating this class the unknown
+   * protection domain is returned which has a <code>null</code> code source
+   * and all permissions. A security check may be performed, with
+   * <code>RuntimePermission("getProtectionDomain")</code>.
+   *
+   * @return the protection domain
+   * @throws SecurityException if the security manager exists and the caller
+   * does not have <code>RuntimePermission("getProtectionDomain")</code>.
+   * @see RuntimePermission
+   * @since 1.2
+   */
+  public ProtectionDomain getProtectionDomain()
+  {
+    SecurityManager sm = SecurityManager.current;
+    if (sm != null)
+      sm.checkPermission(new RuntimePermission("getProtectionDomain"));
 
-/**
- * Lookup a method.
- *
- * Internal helper method used to combine common method lookup operations into a single method.
- *
- * @param name method name
- * @param parameterTypes method's list of parameters
- * @param declared true if the method is supposed to be declared in this class
- * @return the method, if it can be found.
- * @exception NoSuchMethodException if no method can be found
- * @exception SecurityException if access to the method is denied
- */
-private Method lookupMethod (String name, Class [] parameterTypes, boolean declared) throws NoSuchMethodException, SecurityException {
+    return pd == null ? StaticData.unknownProtectionDomain : pd;
+  }
 
-  Method meth = getMethod0(name, parameterTypes, declared);
+  /**
+   * Return the human-readable form of this Object.  For an object, this
+   * is either "interface " or "class " followed by <code>getName()</code>,
+   * for primitive types and void it is just <code>getName()</code>.
+   *
+   * @return the human-readable form of this Object
+   */
+  public String toString()
+  {
+    if (isPrimitive())
+      return getName();
+    return (isInterface() ? "interface " : "class ") + getName();
+  }
 
-  if (meth == null) {
-    StringBuffer buf = new StringBuffer("In class ");
-    buf.append(getName())
-      .append(" there is no method ")
-      .append(name)
-      .append(" (");
-	  
-    /* write parameter types */
-    if (parameterTypes != null) {
-      for (int i = 0; i < parameterTypes.length; ++i) {
-        buf.append(parameterTypes[i].getName());
-        if (i < parameterTypes.length - 1) {
-	  buf.append(", ");
+  /**
+   * Returns the desired assertion status of this class, if it were to be
+   * initialized at this moment. The class assertion status, if set, is
+   * returned; the backup is the default package status; then if there is
+   * a class loader, that default is returned; and finally the system default
+   * is returned. This method seldom needs calling in user code, but exists
+   * for compilers to implement the assert statement. Note that there is no
+   * guarantee that the result of this method matches the class's actual
+   * assertion status.
+   *
+   * @return the desired assertion status
+   * @see ClassLoader#setClassAssertionStatus(String, boolean)
+   * @see ClassLoader#setPackageAssertionStatus(String, boolean)
+   * @see ClassLoader#setDefaultAssertionStatus(boolean)
+   * @since 1.4
+   */
+  public boolean desiredAssertionStatus()
+  {
+    ClassLoader c = getClassLoader();
+    Object status;
+    if (c == null)
+      return VMClassLoader.defaultAssertionStatus();
+    if (c.classAssertionStatus != null)
+      synchronized (c)
+        {
+          status = c.classAssertionStatus.get(getName());
+          if (status != null)
+            return status.equals(Boolean.TRUE);
         }
+    else
+      {
+        status = ClassLoader.StaticData.
+                    systemClassAssertionStatus.get(getName());
+        if (status != null)
+          return status.equals(Boolean.TRUE);
       }
-    }
-
-    buf.append(')');
-
-    throw new NoSuchMethodException(buf.toString());
+    if (c.packageAssertionStatus != null)
+      synchronized (c)
+        {
+          String name = getPackagePortion(getName());
+          if ("".equals(name))
+            status = c.packageAssertionStatus.get(null);
+          else
+            do
+              {
+                status = c.packageAssertionStatus.get(name);
+                name = getPackagePortion(name);
+              }
+            while (! "".equals(name) && status == null);
+          if (status != null)
+            return status.equals(Boolean.TRUE);
+        }
+    else
+      {
+        String name = getPackagePortion(getName());
+        if ("".equals(name))
+          status = ClassLoader.StaticData.
+                    systemPackageAssertionStatus.get(null);
+        else
+          do
+            {
+              status = ClassLoader.StaticData.
+                        systemPackageAssertionStatus.get(name);
+              name = getPackagePortion(name);
+            }
+          while (! "".equals(name) && status == null);
+        if (status != null)
+          return status.equals(Boolean.TRUE);
+      }
+    return c.defaultAssertionStatus;
   }
 
-  return meth;
-}
-
-public Object newInstance() throws InstantiationException, IllegalAccessException {
-    if (Modifier.isAbstract(getModifiers()) || isInterface() || isPrimitive()) {
-	throw new InstantiationException(getName());
-    }
-    else {
-	try {
-	    return getDeclaredConstructor(null).newInstance(null);
-	}
-	catch (InvocationTargetException e) {
-	    // we rethrow runtime exceptions thrown by constructors, in order to
-	    // pass on exceptions like NullPointerException to the caller.
-	    if (e.getTargetException() instanceof RuntimeException) {
-		throw (RuntimeException) e.getTargetException();
-	    }
-	    else {
-		throw new InstantiationException(e.getTargetException().getMessage());
-	    }
-	}
-	catch (NoSuchMethodException e) {
-	    throw new InstantiationException(e.getMessage());
-	}
-    }
-}
+  /**
+   * Like <code>getField(String)</code> but without the security checks and returns null
+   * instead of throwing NoSuchFieldException.
+   */
+  private Field internalGetField(String name)
+  {
+    Field[] fields = getDeclaredFields(true);
+    for (int i = 0; i < fields.length; i++)
+      {
+	Field field = fields[i];
+	if (field.getName().equals(name))
+	  return field;
+      }
+    Class[] interfaces = getInterfaces();
+    for (int i = 0; i < interfaces.length; i++)
+      {
+	Field field = interfaces[i].internalGetField(name);
+	if(field != null)
+	  return field;
+      }
+    Class superClass = getSuperclass();
+    if (superClass != null)
+      return superClass.internalGetField(name);
+    return null;
+  }
 
   /**
    * Strip the last portion of the name (after the last dot).
@@ -451,78 +1295,18 @@ public Object newInstance() throws Insta
   }
 
   /**
-   * Return the human-readable form of this Object.  For an object, this
-   * is either "interface " or "class " followed by <code>getName()</code>,
-   * for primitive types and void it is just <code>getName()</code>.
-   *
-   * @return the human-readable form of this Object
+   * Perform security checks common to all of the methods that
+   * get members of this Class.
    */
-  public String toString()
+  private void memberAccessCheck(int which)
   {
-    if (isPrimitive())
-      return getName();
-    return (isInterface() ? "interface " : "class ") + getName();
+    SecurityManager sm = SecurityManager.current;
+    if (sm != null)
+      {
+	sm.checkMemberAccess(this, which);
+	Package pkg = getPackage();
+	if (pkg != null)
+	  sm.checkPackageAccess(pkg.getName());
+      }
   }
-
-/**
- * Returns the desired assertion status of this class, if it were to be
- * initialized at this moment. The class assertion status, if set, is
- * returned; the backup is the default package status; then if there is
- * a class loader, that default is returned; and finally the system default
- * is returned. This method seldom needs calling in user code, but exists
- * for compilers to implement the assert statement. Note that there is no
- * guarantee that the result of this method matches the class's actual
- * assertion status.
- *
- * @return the desired assertion status
- * @see ClassLoader#setClassAssertionStatus(String, boolean)
- * @see ClassLoader#setPackageAssertionStatus(String, boolean)
- * @see ClassLoader#setDefaultAssertionStatus(boolean)
- * @since 1.4
- */
-public boolean desiredAssertionStatus() {
-	ClassLoader c = getClassLoader();
-	Object status;
-	if (c == null)
-		return VMClassLoader.defaultAssertionStatus();
-	if (c.classAssertionStatus != null) {
-		synchronized (c) {
-			status = c.classAssertionStatus.get(getName());
-			if (status != null)
-				return status.equals(Boolean.TRUE);
-		}
-	} else {
-		status = ClassLoader.StaticData.systemClassAssertionStatus.get(getName());
-		if (status != null)
-			return status.equals(Boolean.TRUE);
-	}
-	if (c.packageAssertionStatus != null) {
-		synchronized (c) {
-			String name = getPackagePortion(getName());
-			if ("".equals(name))
-				status = c.packageAssertionStatus.get(null);
-			else {
-				do {
-					status = c.packageAssertionStatus.get(name);
-					name = getPackagePortion(name);
-				} while (! "".equals(name) && status == null);
-			}
-			if (status != null)
-				return status.equals(Boolean.TRUE);
-		}
-	} else {
-		String name = getPackagePortion(getName());
-		if ("".equals(name))
-			status = ClassLoader.StaticData.systemPackageAssertionStatus.get(null);
-		else {
-			do {
-				status = ClassLoader.StaticData.systemPackageAssertionStatus.get(name);
-				name = getPackagePortion(name);
-			} while (! "".equals(name) && status == null);
-		}
-		if (status != null)
-			return status.equals(Boolean.TRUE);
-	}
-	return c.defaultAssertionStatus;
-}
 }
Index: libraries/javalib/java/lang/Double.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Double.java,v
retrieving revision 1.20
diff -u -p -r1.20 Double.java
--- libraries/javalib/java/lang/Double.java	12 Aug 2003 23:02:18 -0000	1.20
+++ libraries/javalib/java/lang/Double.java	5 Jan 2005 14:54:24 -0000
@@ -25,7 +25,7 @@ public final class Double extends Number
   public static final double MIN_VALUE		= 4.9406564584124654418e-324;
   public static final double MAX_VALUE		= 1.7976931348623157081e+308;
 
-  public static final Class TYPE = Class.getPrimitiveClass("double");
+  public static final Class TYPE = VMClassLoader.getPrimitiveClass('D');
 
   private static final int MAX_DIGITS = 19;
 
Index: libraries/javalib/java/lang/Float.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Float.java,v
retrieving revision 1.21
diff -u -p -r1.21 Float.java
--- libraries/javalib/java/lang/Float.java	12 Aug 2003 23:02:18 -0000	1.21
+++ libraries/javalib/java/lang/Float.java	5 Jan 2005 14:54:24 -0000
@@ -25,7 +25,7 @@ public final class Float extends Number 
   public static final float MIN_VALUE		= 1.4012984643248170709e-45f;
   public static final float MAX_VALUE		= 3.4028234663852885981e+38f;
 
-  public static final Class TYPE = Class.getPrimitiveClass("float");
+  public static final Class TYPE = VMClassLoader.getPrimitiveClass('F');
   private static final int MAX_DIGITS = 10;
 
   private final float value;
Index: libraries/javalib/java/lang/Integer.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Integer.java,v
retrieving revision 1.23
diff -u -p -r1.23 Integer.java
--- libraries/javalib/java/lang/Integer.java	2 Jun 2003 16:24:33 -0000	1.23
+++ libraries/javalib/java/lang/Integer.java	5 Jan 2005 14:54:24 -0000
@@ -13,7 +13,7 @@ package java.lang;
 final public class Integer extends Number implements Comparable {
 
 	private int value;
-	final public static Class TYPE = Class.getPrimitiveClass("int");
+	final public static Class TYPE = VMClassLoader.getPrimitiveClass('I');
 	final public static int MIN_VALUE = 0x80000000;
 	final public static int MAX_VALUE = 0x7fffffff;
 	final private static long serialVersionUID = 1360826667806852920L;
Index: libraries/javalib/java/lang/Long.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Long.java,v
retrieving revision 1.20
diff -u -p -r1.20 Long.java
--- libraries/javalib/java/lang/Long.java	20 Feb 2003 13:52:09 -0000	1.20
+++ libraries/javalib/java/lang/Long.java	5 Jan 2005 14:54:24 -0000
@@ -16,7 +16,7 @@ final public class Long extends Number i
 	final private long value;
 	final public static long MIN_VALUE = 0x8000000000000000L;
 	final public static long MAX_VALUE = 0x7fffffffffffffffL;
-	final public static Class TYPE = Class.getPrimitiveClass("long");
+	final public static Class TYPE = VMClassLoader.getPrimitiveClass('J');
 
 	/* This is what Sun's JDK1.1 "serialver java.lang.Long" spits out */ 
 	private static final long serialVersionUID = 4290774380558885855L;
Index: libraries/javalib/java/lang/Short.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Short.java,v
retrieving revision 1.11
diff -u -p -r1.11 Short.java
--- libraries/javalib/java/lang/Short.java	20 Feb 2003 13:52:09 -0000	1.11
+++ libraries/javalib/java/lang/Short.java	5 Jan 2005 14:54:24 -0000
@@ -14,7 +14,7 @@ final public class Short extends Number 
 
 	final public static short MIN_VALUE = -0x8000;
 	final public static short MAX_VALUE = 0x7FFF;
-	final public static Class TYPE = Class.getPrimitiveClass("short");
+	final public static Class TYPE = VMClassLoader.getPrimitiveClass('S');
 	final private short value;
 
 	/* This is what Sun's JDK1.1 "serialver java.lang.Short" spits out */ 
Index: libraries/javalib/java/lang/System.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/System.java,v
retrieving revision 1.44
diff -u -p -r1.44 System.java
--- libraries/javalib/java/lang/System.java	3 Jan 2005 06:44:22 -0000	1.44
+++ libraries/javalib/java/lang/System.java	5 Jan 2005 14:54:25 -0000
@@ -35,10 +35,8 @@ public final class System {
 // JVM initialization, eg, before System.err is initialized, debugging
 // println() statements don't work. In these cases, the following routines
 // are very handy. Simply uncomment the following two lines to enable them.
-/****
 public static native void debug(String s);	// print s to stderr, then \n
 public static native void debugE(Throwable t);	// print stack trace to stderr
-****/
 static {
 	// Initialise the I/O
 	if (SystemProperties.getProperty("kaffe.embedded", "false").equals("false")) {
Index: libraries/javalib/java/lang/VMClass.java
===================================================================
RCS file: libraries/javalib/java/lang/VMClass.java
diff -N libraries/javalib/java/lang/VMClass.java
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ libraries/javalib/java/lang/VMClass.java	5 Jan 2005 14:54:25 -0000
@@ -0,0 +1,296 @@
+/* VMClass.java -- VM Specific Class methods
+   Copyright (C) 2003, 2004 Free Software Foundation
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+package java.lang;
+
+import java.lang.reflect.Constructor;
+import java.lang.reflect.Field;
+import java.lang.reflect.Method;
+
+/*
+ * This class is a reference version, mainly for compiling a class library
+ * jar.  It is likely that VM implementers replace this with their own
+ * version that can communicate effectively with the VM.
+ */
+
+/**
+ *
+ * @author Etienne Gagnon <etienne.gagnon@uqam.ca>
+ * @author Archie Cobbs <archie@dellroad.org>
+ * @author C. Brian Jones <cbj@gnu.org>
+ */
+final class VMClass 
+{
+
+  // Only static methods. Cannot be instantiated.
+  private VMClass()
+  {
+  }
+
+  /**
+   * Discover whether an Object is an instance of this Class.  Think of it
+   * as almost like <code>o instanceof (this class)</code>.
+   *
+   * @param klass the Class object that's calling us
+   * @param o the Object to check
+   * @return whether o is an instance of this class
+   * @since 1.1
+   */
+  static native boolean isInstance(Class klass, Object o);
+
+  /**
+   * Discover whether an instance of the Class parameter would be an
+   * instance of this Class as well.  Think of doing
+   * <code>isInstance(c.newInstance())</code> or even
+   * <code>c.newInstance() instanceof (this class)</code>. While this
+   * checks widening conversions for objects, it must be exact for primitive
+   * types.
+   *
+   * @param klass the Class object that's calling us
+   * @param c the class to check
+   * @return whether an instance of c would be an instance of this class
+   *         as well
+   * @throws NullPointerException if c is null
+   * @since 1.1
+   */
+  static native boolean isAssignableFrom(Class klass, Class c);
+
+  /**
+   * Check whether this class is an interface or not.  Array types are not
+   * interfaces.
+   *
+   * @param klass the Class object that's calling us
+   * @return whether this class is an interface or not
+   */
+  static native boolean isInterface(Class klass);
+
+  /**
+   * Return whether this class is a primitive type.  A primitive type class
+   * is a class representing a kind of "placeholder" for the various
+   * primitive types, or void.  You can access the various primitive type
+   * classes through java.lang.Boolean.TYPE, java.lang.Integer.TYPE, etc.,
+   * or through boolean.class, int.class, etc.
+   *
+   * @param klass the Class object that's calling us
+   * @return whether this class is a primitive type
+   * @see Boolean#TYPE
+   * @see Byte#TYPE
+   * @see Character#TYPE
+   * @see Short#TYPE
+   * @see Integer#TYPE
+   * @see Long#TYPE
+   * @see Float#TYPE
+   * @see Double#TYPE
+   * @see Void#TYPE
+   * @since 1.1
+   */
+  static native boolean isPrimitive(Class klass);
+
+  /**
+   * Get the name of this class, separated by dots for package separators.
+   * Primitive types and arrays are encoded as:
+   * <pre>
+   * boolean             Z
+   * byte                B
+   * char                C
+   * short               S
+   * int                 I
+   * long                J
+   * float               F
+   * double              D
+   * void                V
+   * array type          [<em>element type</em>
+   * class or interface, alone: &lt;dotted name&gt;
+   * class or interface, as element type: L&lt;dotted name&gt;;
+   *
+   * @param klass the Class object that's calling us
+   * @return the name of this class
+   */
+  static native String getName(Class klass);
+
+  /**
+   * Get the direct superclass of this class.  If this is an interface,
+   * Object, a primitive type, or void, it will return null. If this is an
+   * array type, it will return Object.
+   *
+   * @param klass the Class object that's calling us
+   * @return the direct superclass of this class
+   */
+  static native Class getSuperclass(Class klass);
+
+  /**
+   * Get the interfaces this class <EM>directly</EM> implements, in the
+   * order that they were declared. This returns an empty array, not null,
+   * for Object, primitives, void, and classes or interfaces with no direct
+   * superinterface. Array types return Cloneable and Serializable.
+   *
+   * @param klass the Class object that's calling us
+   * @return the interfaces this class directly implements
+   */
+  static native Class[] getInterfaces(Class klass);
+
+  /**
+   * If this is an array, get the Class representing the type of array.
+   * Examples: "[[Ljava.lang.String;" would return "[Ljava.lang.String;", and
+   * calling getComponentType on that would give "java.lang.String".  If
+   * this is not an array, returns null.
+   *
+   * @param klass the Class object that's calling us
+   * @return the array type of this class, or null
+   * @see Array
+   * @since 1.1
+   */
+  static native Class getComponentType(Class klass);
+
+  /**
+   * Get the modifiers of this class.  These can be decoded using Modifier,
+   * and is limited to one of public, protected, or private, and any of
+   * final, static, abstract, or interface. An array class has the same
+   * public, protected, or private modifier as its component type, and is
+   * marked final but not an interface. Primitive types and void are marked
+   * public and final, but not an interface.
+   *
+   * @param klass the Class object that's calling us
+   * @return the modifiers of this class
+   * @see Modifer
+   * @since 1.1
+   */
+  static native int getModifiers(Class klass);
+
+  /**
+   * If this is a nested or inner class, return the class that declared it.
+   * If not, return null.
+   *
+   * @param klass the Class object that's calling us
+   * @return the declaring class of this class
+   * @since 1.1
+   */
+  static native Class getDeclaringClass(Class klass);
+
+  /**
+   * Like <code>getDeclaredClasses()</code> but without the security checks.
+   *
+   * @param klass the Class object that's calling us
+   * @param pulicOnly Only public classes should be returned
+   */
+  static native Class[] getDeclaredClasses(Class klass, boolean publicOnly);
+
+  /**
+   * Like <code>getDeclaredFields()</code> but without the security checks.
+   *
+   * @param klass the Class object that's calling us
+   * @param pulicOnly Only public fields should be returned
+   */
+  static native Field[] getDeclaredFields(Class klass, boolean publicOnly);
+
+  /**
+   * Like <code>getDeclaredMethods()</code> but without the security checks.
+   *
+   * @param klass the Class object that's calling us
+   * @param pulicOnly Only public methods should be returned
+   */
+  static native Method[] getDeclaredMethods(Class klass, boolean publicOnly);
+
+  /**
+   * Like <code>getDeclaredConstructors()</code> but without
+   * the security checks.
+   *
+   * @param klass the Class object that's calling us
+   * @param pulicOnly Only public constructors should be returned
+   */
+  static native Constructor[] getDeclaredConstructors(Class klass, boolean publicOnly);
+
+  /**
+   * Return the class loader of this class.
+   *
+   * @param klass the Class object that's calling us
+   * @return the class loader
+   */
+  static native ClassLoader getClassLoader(Class klass);
+
+  /**
+   * VM implementors are free to make this method a noop if 
+   * the default implementation is acceptable.
+   *
+   * @param name the name of the class to find
+   * @return the Class object representing the class or null for noop
+   * @throws ClassNotFoundException if the class was not found by the
+   *         classloader
+   * @throws LinkageError if linking the class fails
+   * @throws ExceptionInInitializerError if the class loads, but an exception
+   *         occurs during initialization
+   */
+  static Class forName(String name) throws ClassNotFoundException
+   { return null; }
+
+   private static native Class forName0(String name, ClassLoader loader);
+
+  /**
+   * Return whether this class is an array type.
+   *
+   * @param klass the Class object that's calling us
+   * @return true if this class is an array type
+   * operation
+   */
+  static native boolean isArray(Class klass);
+
+  /**
+   * This method should trigger class initialization (if the
+   * class hasn't already been initialized)
+   * 
+   * @param klass the Class object that's calling us
+   * @throws ExceptionInInitializerError if an exception
+   *         occurs during initialization
+   */
+  static native void initialize(Class klass);
+
+  /**
+   * Load an array class.
+   *
+   * @return the Class object representing the class
+   * @throws ClassNotFoundException if the class was not found by the
+   *         classloader
+   */
+  static native Class loadArrayClass(String name, ClassLoader classloader)
+	throws ClassNotFoundException;
+
+  /**
+   * Throw a checked exception without declaring it.
+   */
+  static native void throwException(Throwable t);
+
+} // class VMClass
Index: libraries/javalib/java/lang/VMClassLoader.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/VMClassLoader.java,v
retrieving revision 1.1
diff -u -p -r1.1 VMClassLoader.java
--- libraries/javalib/java/lang/VMClassLoader.java	21 Dec 2004 16:51:12 -0000	1.1
+++ libraries/javalib/java/lang/VMClassLoader.java	5 Jan 2005 14:54:25 -0000
@@ -193,57 +193,7 @@ final class VMClassLoader
    * @param type the primitive type
    * @return a "bogus" class representing the primitive type
    */
-  static final Class getPrimitiveClass(char type)
-  {
-    String t;
-    switch (type)
-      {
-      case 'Z':
-        t = "boolean";
-        break;
-      case 'B':
-        t = "byte";
-        break;
-      case 'C':
-        t = "char";
-        break;
-      case 'D':
-        t = "double";
-        break;
-      case 'F':
-        t = "float";
-        break;
-      case 'I':
-        t = "int";
-        break;
-      case 'J':
-        t = "long";
-        break;
-      case 'S':
-        t = "short";
-        break;
-      case 'V':
-        t = "void";
-        break;
-      default:
-        throw new NoClassDefFoundError("Invalid type specifier: " + type);
-      }
-    return getPrimitiveClass(t);
-  }
-
-  /**
-   * Old version of the interface, added here for backwards compatibility.
-   * Called by the java version of getPrimitiveClass(char) when no native
-   * version of that method is available.
-   * <strong>This method will be removed in a future version of GNU
-   * Classpath</strong>.
-   * @param type the primitive type
-   * @return a "bogus" class representing the primitive type
-   */
-  static Class getPrimitiveClass(String type)
-  {
-    throw new InternalError ();
-  }
+  static native Class getPrimitiveClass(char type);
 
   /**
    * The system default for assertion status. This is used for all system
Index: libraries/javalib/java/lang/VMSecurityManager.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/VMSecurityManager.java,v
retrieving revision 1.3
diff -u -p -r1.3 VMSecurityManager.java
--- libraries/javalib/java/lang/VMSecurityManager.java	6 Dec 2004 00:15:33 -0000	1.3
+++ libraries/javalib/java/lang/VMSecurityManager.java	5 Jan 2005 14:54:25 -0000
@@ -58,17 +58,27 @@ final class VMSecurityManager
    * @return an array of the declaring classes of each stack frame
    */
   static Class[] getClassContext() {
+     /*
+      * rawStack looks like this:
+      *         ThreadStack.getClassStack()
+      *         VMSecuritymanager.getClassContext
+      *         <some other strange class, either Class or SecurityManager>
+      *         
+      */
     Class[] rawStack = ThreadStack.getClassStack();
-    int i = 0;
-    while (i < rawStack.length
-	   && (rawStack[i] == ThreadStack.class
-	       || rawStack[i] == VMSecurityManager.class
-	       || rawStack[i] == SecurityManager.class))
-      i++;
+    int i = 2; // skips ThreadStack and VMSecurityManager.getClassContext
 
+    // skip java.lang.SecurityManager or java.lang.Class
+    while (rawStack[i] == rawStack[2])
+       i++;
+
+    // skip invocation via reflection
+    while (rawStack[i].getName() == "java.lang.reflect.Method")
+       i++;
+ 
     Class[] stack = new Class[rawStack.length - i];
-    for (int j = 0; j < stack.length; j++, i++)
-      stack[j] = rawStack[i];
+
+    System.arraycopy(rawStack, i, stack, 0, stack.length);
 
     return stack;
   }
Index: libraries/javalib/java/lang/Void.java
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/javalib/java/lang/Void.java,v
retrieving revision 1.4
diff -u -p -r1.4 Void.java
--- libraries/javalib/java/lang/Void.java	15 Oct 2004 14:25:01 -0000	1.4
+++ libraries/javalib/java/lang/Void.java	5 Jan 2005 14:54:25 -0000
@@ -57,7 +57,7 @@ public final class Void
    * The return type <code>void</code> is represented by this
    * <code>Class</code> object.
    */
-  public static final Class TYPE = Class.getPrimitiveClass("void");
+  public static final Class TYPE = VMClassLoader.getPrimitiveClass('V');
 
   /**
    * Void is non-instantiable.
Index: libraries/clib/native/Class.c
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/clib/native/Class.c,v
retrieving revision 1.79
diff -u -p -r1.79 Class.c
--- libraries/clib/native/Class.c	21 Dec 2004 17:31:28 -0000	1.79
+++ libraries/clib/native/Class.c	5 Jan 2005 14:54:25 -0000
@@ -41,9 +41,7 @@
  * Convert string name to class object.
  */
 struct Hjava_lang_Class*
-java_lang_Class_forName(struct Hjava_lang_String* str,
-			jbool doinit,
-			Hjava_lang_ClassLoader* loader)
+java_lang_VMClass_forName0(struct Hjava_lang_String* str, struct Hjava_lang_ClassLoader* loader)
 {
 	errorInfo einfo;
 	Hjava_lang_Class* clazz;
@@ -115,17 +113,70 @@ java_lang_Class_forName(struct Hjava_lan
 	 * was introduced in 1.2, presumably for the convenience of
 	 * programs such as stub compilers.
 	 */
-	if (doinit && processClass(clazz, CSTATE_COMPLETE, &einfo) == false) {
+	if (processClass(clazz, CSTATE_COMPLETE, &einfo) == false) {
 		throwError(&einfo);
 	}
 	return (clazz);
 }
 
+struct Hjava_lang_Class*
+java_lang_VMClass_loadArrayClass(struct Hjava_lang_String* str, struct Hjava_lang_ClassLoader* loader)
+{
+	errorInfo einfo;
+	Hjava_lang_Class* clazz;
+	Utf8Const *utf8buf;
+	const char *buf;
+	int jlen;
+	jchar *js;
+
+	/*
+	 * NB: internally, we store class names as path names (with slashes
+	 *     instead of dots.  However, we must also prevent calls to
+	 *     "java/lang/Object" or "[[Ljava/lang/Object;" from succeeding.
+	 *	Since class names cannot have slashes, we reject all attempts
+	 *	to look up names that do.  Awkward.  Inefficient.
+	 */
+	js = STRING_DATA(str);
+	jlen = STRING_SIZE(str);
+	while (--jlen > 0) {
+		if (*js++ == '/') {
+			postExceptionMessage(&einfo,
+				JAVA_LANG(ClassNotFoundException),
+				"Cannot have slashes - use dots instead.");
+			throwError(&einfo);
+		}
+	}
+
+	/* Convert string to utf8, converting '.' to '/' */
+	utf8buf = checkPtr(stringJava2Utf8ConstReplace(str, '.', '/'));
+	buf = utf8buf->data;
+	clazz = loadArray(utf8buf, loader, &einfo);
+
+	/* if an error occurred, throw an exception */
+	if (clazz == 0) {
+		utf8ConstRelease(utf8buf);
+		throwError(&einfo);
+	}
+	utf8ConstRelease(utf8buf);
+
+	return clazz;
+}
+
+void
+java_lang_VMClass_initialize(struct Hjava_lang_Class* c)
+{
+	errorInfo einfo;
+
+	if (processClass(c, CSTATE_COMPLETE, &einfo) == false) {
+		throwError(&einfo);
+	}
+}
+
 /*
  * Convert class to string name.
  */
 struct Hjava_lang_String*
-java_lang_Class_getName(struct Hjava_lang_Class* c)
+java_lang_VMClass_getName(struct Hjava_lang_Class* c)
 {
 	return(checkPtr(utf8Const2JavaReplace(c->name, '/', '.')));
 }
@@ -143,7 +194,7 @@ java_lang_Class_getName(struct Hjava_lan
  * superinterface(s).  See also getInterfaceMethods0.
  */
 struct Hjava_lang_Class*
-java_lang_Class_getSuperclass(struct Hjava_lang_Class* this)
+java_lang_VMClass_getSuperclass(struct Hjava_lang_Class* this)
 {
 	if (!CLASS_IS_INTERFACE(this))
 		return (this->superclass);
@@ -152,7 +203,7 @@ java_lang_Class_getSuperclass(struct Hja
 }
 
 HArrayOfObject* /* [Ljava.lang.Class; */
-java_lang_Class_getInterfaces(struct Hjava_lang_Class* this)
+java_lang_VMClass_getInterfaces(struct Hjava_lang_Class* this)
 {
 	HArrayOfObject* obj;
 	struct Hjava_lang_Class** ifaces;
@@ -183,7 +234,7 @@ java_lang_Class_getInterfaces(struct Hja
  * Return the class loader which loaded me.
  */
 struct Hjava_lang_ClassLoader*
-java_lang_Class_getClassLoader0(struct Hjava_lang_Class* this)
+java_lang_VMClass_getClassLoader(struct Hjava_lang_Class* this)
 {
 	return (this->loader);
 }
@@ -192,87 +243,51 @@ java_lang_Class_getClassLoader0(struct H
  * Is the class an interface?
  */
 jbool
-java_lang_Class_isInterface(struct Hjava_lang_Class* this)
+java_lang_VMClass_isInterface(struct Hjava_lang_Class* this)
 {
 	return ((this->accflags & ACC_INTERFACE) ? 1 : 0);
 }
 
 jbool
-java_lang_Class_isPrimitive(struct Hjava_lang_Class* this)
+java_lang_VMClass_isPrimitive(struct Hjava_lang_Class* this)
 {
 	return (CLASS_IS_PRIMITIVE(this));
 }
 
 jbool
-java_lang_Class_isArray(struct Hjava_lang_Class* this)
+java_lang_VMClass_isArray(struct Hjava_lang_Class* this)
 {
 	return (CLASS_IS_ARRAY(this));
 }
 
 Hjava_lang_Class*
-java_lang_Class_getComponentType(struct Hjava_lang_Class* this)
+java_lang_VMClass_getComponentType(struct Hjava_lang_Class* this)
 {
 	if (CLASS_IS_ARRAY(this)) {
 		return (CLASS_ELEMENT_TYPE(this));
 	}
 	else {
-		return ((Hjava_lang_Class*)0);
+		return ((Hjava_lang_Class*)NULL);
 	}
 }
 
 jbool
-java_lang_Class_isAssignableFrom(struct Hjava_lang_Class* this, struct Hjava_lang_Class* cls)
+java_lang_VMClass_isAssignableFrom(struct Hjava_lang_Class* this, struct Hjava_lang_Class* cls)
 {
 	return (instanceof(this, cls));
 }
 
 /*
- * Get primitive class from class name (JDK 1.1)
- */
-struct Hjava_lang_Class*
-java_lang_Class_getPrimitiveClass(struct Hjava_lang_String* name)
-{
-	jchar* chrs;
-
-	chrs = STRING_DATA(name);
-	switch (chrs[0]) {
-	case 'b':
-		if (chrs[1] == 'y') {
-			return (byteClass);
-		}
-		if (chrs[1] == 'o') {
-			return (booleanClass);
-		}
-		break;
-	case 'c':
-		return (charClass);
-	case 'd':
-		return (doubleClass);
-	case 'f':
-		return (floatClass);
-	case 'i':
-		return (intClass);
-	case 'l':
-		return (longClass);
-	case 's':
-		return (shortClass);
-	case 'v':
-		return (voidClass);
-	}
-	return(NULL);
-}
-
-/*
  * Is object instance of this class?
  */
 jbool
-java_lang_Class_isInstance(struct Hjava_lang_Class* this, struct Hjava_lang_Object* obj)
+java_lang_VMClass_isInstance(struct Hjava_lang_Class* this, struct Hjava_lang_Object* obj)
 {
 	return (soft_instanceof(this, obj));
 }
 
 jint
-java_lang_Class_getModifiers(struct Hjava_lang_Class* this)
+java_lang_VMClass_getModifiers(struct Hjava_lang_Class* this)
 {
 #ifndef ACC_SUPER
 #define ACC_SUPER ACC_SYNCHRONISED
@@ -280,24 +295,6 @@ java_lang_Class_getModifiers(struct Hjav
 	return (this->accflags & (ACC_MASK & ~ACC_SUPER));
 }
 
-HArrayOfObject*
-java_lang_Class_getSigners0(struct Hjava_lang_Class* this)
-{
-	return this->signers;
-}
-
-void
-java_lang_Class_setSigners(struct Hjava_lang_Class* this, HArrayOfObject* sigs)
-{
-	unhand(this)->signers = sigs;
-}
-
-struct Hjava_security_ProtectionDomain*
-java_lang_Class_getProtectionDomain (struct Hjava_lang_Class* this)
-{
-	return unhand(this)->protectionDomain;
-}
-
 /*
  * Return true if there is method defined in any subclass of 'cls'
  * that overrides 'meth'.
@@ -333,16 +330,16 @@ isOverridden(Hjava_lang_Class *base, Hja
  * If declared is not set, count only public methods.
  */
 static int
-countMethods(Hjava_lang_Class* base, Hjava_lang_Class* clas, jint declared)
+countMethods(Hjava_lang_Class* base, Hjava_lang_Class* clas, jboolean publicOnly)
 {
 	Method* mth = CLASS_METHODS(clas);
 	int i;
 	int count = 0;
 
 	for (i = CLASS_NMETHODS(clas)-1 ; i >= 0; i--) {
-		if (((mth[i].accflags & ACC_PUBLIC) || declared)
+		if (((mth[i].accflags & ACC_PUBLIC) || !publicOnly)
 		    && !(mth[i].accflags & ACC_CONSTRUCTOR)
-		    && !isOverridden(base, clas, mth + i)
+		/*    && !isOverridden(base, clas, mth + i) */
 		    && !utf8ConstEqual(init_name, mth[i].name)) {
 			count++;
 		}
@@ -355,16 +352,16 @@ countMethods(Hjava_lang_Class* base, Hja
  * not constructors.  If declared is not set, include only public methods.
  */
 static void
-addMethods(Hjava_lang_Class* base, Hjava_lang_Class* clas, jint declared,
+addMethods(Hjava_lang_Class* base, Hjava_lang_Class* clas, jboolean publicOnly,
 	Hjava_lang_reflect_Method*** ptr)
 {
 	Method* mth = CLASS_METHODS(clas);
 	int i;
 
 	for (i = CLASS_NMETHODS(clas)-1; i >= 0; i--) {
-		if (((mth[i].accflags & ACC_PUBLIC) || declared)
+		if (((mth[i].accflags & ACC_PUBLIC) || !publicOnly)
 		    && !(mth[i].accflags & ACC_CONSTRUCTOR)
-		    && !isOverridden(base, clas, mth + i)
+		/*    && !isOverridden(base, clas, mth + i) */
 		    && !utf8ConstEqual(init_name, mth[i].name)) {
 			**ptr = KaffeVM_makeReflectMethod(clas, i);
 			(*ptr)++;
@@ -387,7 +384,7 @@ addMethods(Hjava_lang_Class* base, Hjava
  */
 static
 HArrayOfObject*
-getInterfaceMethods0(struct Hjava_lang_Class* this, jint declared)
+getInterfaceMethods0(struct Hjava_lang_Class* this, jboolean publicOnly)
 {
 	int count;
 	Hjava_lang_reflect_Method** ptr;
@@ -395,10 +392,10 @@ getInterfaceMethods0(struct Hjava_lang_C
 	int i;
 
 	count = 0;
-	count += countMethods(NULL, this, declared);
-	if (!declared) {
+	count += countMethods(NULL, this, publicOnly);
+	if (!publicOnly) {
 		for (i = 0; i < this->total_interface_len; i++) {
-			count += countMethods(NULL, this->interfaces[i], declared);
+			count += countMethods(NULL, this->interfaces[i], publicOnly);
 		}
 	}
 
@@ -406,10 +403,10 @@ getInterfaceMethods0(struct Hjava_lang_C
 	    AllocObjectArray(count, "Ljava/lang/reflect/Method;", NULL);
 	ptr = (Hjava_lang_reflect_Method**)&unhand_array(array)->body[0];
 
-	addMethods(NULL, this, declared, &ptr);
-	if (!declared) {
+	addMethods(NULL, this, publicOnly, &ptr);
+	if (!publicOnly) {
 		for (i = 0; i < this->total_interface_len; i++) {
-			addMethods(NULL, this->interfaces[i], declared, &ptr);
+			addMethods(NULL, this->interfaces[i], publicOnly, &ptr);
 		}
 	}
 
@@ -417,49 +414,23 @@ getInterfaceMethods0(struct Hjava_lang_C
 }
 
 HArrayOfObject*
-java_lang_Class_getMethods0(struct Hjava_lang_Class* this, jboolean declared)
+java_lang_VMClass_getDeclaredMethods(struct Hjava_lang_Class* this, jboolean publicOnly)
 {
 	int count;
-	Hjava_lang_Class* clas;
 	Hjava_lang_reflect_Method** ptr;
 	HArrayOfObject* array;
 
-	/*
-	 * Note: the spec wants us to include the methods of all superclasses
-	 * and all superinterfaces.
-	 *
-	 * Superinterfaces cannot be reached through the superclass
-	 * pointer.  We handle them in a separate function.
-	 */
-	if (CLASS_IS_INTERFACE(this))
-		return (getInterfaceMethods0(this, declared));
-
-	count = 0;
-	for (clas = this; clas != NULL; clas = clas->superclass) {
-
-		count += countMethods(this, clas, declared);
-
-		if (declared) {
-			break;
-		}
-	}
+	count = countMethods(this, this, publicOnly);
 	array = (HArrayOfObject*)
 	    AllocObjectArray(count, "Ljava/lang/reflect/Method;", NULL);
 	ptr = (Hjava_lang_reflect_Method**)&unhand_array(array)->body[0];
-	for (clas = this; clas != NULL; clas = clas->superclass) {
-
-		addMethods(this, clas, declared, &ptr);
-
-		if (declared) {
-			break;
-		}
-	}
+	addMethods(this, this, publicOnly, &ptr);
 
 	return (array);
 }
 
 HArrayOfObject*
-java_lang_Class_getConstructors0(struct Hjava_lang_Class* this, jboolean declared)
+java_lang_VMClass_getDeclaredConstructors(struct Hjava_lang_Class* this, jboolean publicOnly)
 {
 	int count;
 	Hjava_lang_Class* clas;
@@ -472,7 +443,7 @@ java_lang_Class_getConstructors0(struct 
 	clas = this;
 	mth = CLASS_METHODS(clas);
 	for (i = CLASS_NMETHODS(clas)-1; i >= 0;  i--) {
-		if (((mth[i].accflags & ACC_PUBLIC) || declared) && (mth[i].accflags & ACC_CONSTRUCTOR)) {
+		if (((mth[i].accflags & ACC_PUBLIC) || !publicOnly) && (mth[i].accflags & ACC_CONSTRUCTOR)) {
 			count++;
 		}
 	}
@@ -482,7 +453,7 @@ java_lang_Class_getConstructors0(struct 
 	clas = this;
 	mth = CLASS_METHODS(clas);
 	for (i = CLASS_NMETHODS(clas)-1; i >= 0;  i--) {
-		if (((mth[i].accflags & ACC_PUBLIC) || declared) && (mth[i].accflags & ACC_CONSTRUCTOR)) {
+		if (((mth[i].accflags & ACC_PUBLIC) || !publicOnly) && (mth[i].accflags & ACC_CONSTRUCTOR)) {
 			*ptr = KaffeVM_makeReflectConstructor(clas, i);
 			ptr++;
 		}
@@ -498,46 +469,30 @@ static int
 countPublicFields(Hjava_lang_Class* clazz)
 {
 	Hjava_lang_Class* clas;
-	int i, count;
+	int i, count = 0;
+	Field *fld = CLASS_FIELDS(clas);
 
-	count = 0;
-	for (clas = clazz; clas != NULL; clas = clas->superclass) {
-		Field *fld = CLASS_FIELDS(clas);
-		for (i = CLASS_NFIELDS(clas)-1; i >= 0; i--) {
-			if (fld[i].accflags & ACC_PUBLIC) {
-				count++;
-			}
+	for (i = CLASS_NFIELDS(clas)-1; i >= 0; i--) {
+		if (fld[i].accflags & ACC_PUBLIC) {
+			count++;
 		}
 	}
 
-	for (i = 0; i < clazz->total_interface_len; i++) {
-		count += countPublicFields(clazz->interfaces[i]);
-	}
 	return (count);
 }
 
 static void
-makePublicFields(Hjava_lang_Class* clazz, jboolean declared, Hjava_lang_reflect_Field*** pptr)
+makePublicFields(Hjava_lang_Class* clazz, jboolean publicOnly, Hjava_lang_reflect_Field*** pptr)
 {
 	Hjava_lang_Class* clas;
 	Hjava_lang_reflect_Field** ptr = *pptr;
 	int i;
-
-	for (clas = clazz; clas != NULL; clas = clas->superclass) {
-		Field *fld = CLASS_FIELDS(clas);
-		for (i = CLASS_NFIELDS(clas)-1; i >= 0;  i--) {
-			if ((fld[i].accflags & ACC_PUBLIC) || declared) {
-				*ptr = KaffeVM_makeReflectField(clas, i);
-				ptr++;
-			}
-		}
-		if (declared) {
-			break;
-		}
-	}
-	if (!declared) {
-		for (i = 0; i < clazz->total_interface_len; i++) {
-			makePublicFields(clazz->interfaces[i], declared, &ptr);
+	Field *fld = CLASS_FIELDS(clas);
+	
+	for (i = CLASS_NFIELDS(clas)-1; i >= 0;  i--) {
+		if ((fld[i].accflags & ACC_PUBLIC) || !publicOnly) {
+			*ptr = KaffeVM_makeReflectField(clas, i);
+			ptr++;
 		}
 	}
 	*pptr = ptr;
@@ -553,13 +508,13 @@ makePublicFields(Hjava_lang_Class* clazz
  * fields.  Weird semantics.
  */
 HArrayOfObject*
-java_lang_Class_getFields0(struct Hjava_lang_Class* clazz, jboolean declared)
+java_lang_VMClass_getDeclaredFields(struct Hjava_lang_Class* clazz, jboolean publicOnly)
 {
 	int count;
 	Hjava_lang_reflect_Field** ptr;
 	HArrayOfObject* array;
 
-	if (declared) {
+	if (!publicOnly) {
 		count = CLASS_NFIELDS((Hjava_lang_Class*)clazz);
 	}
 	else {
@@ -568,7 +523,7 @@ java_lang_Class_getFields0(struct Hjava_
 	array = (HArrayOfObject*)
 	    AllocObjectArray(count, "Ljava/lang/reflect/Field;", NULL);
 	ptr = (Hjava_lang_reflect_Field**)&unhand_array(array)->body[0];
-	makePublicFields(clazz, declared, &ptr);
+	makePublicFields(clazz, publicOnly, &ptr);
 
 	return (array);
 }
@@ -774,8 +729,28 @@ java_lang_Class_getField0(struct Hjava_l
         return (f);
 }
 
+Hjava_lang_Class*
+java_lang_VMClass_getDeclaringClass(struct Hjava_lang_Class* this)
+{
+	errorInfo		einfo;
+	Hjava_lang_Class 	*ret = NULL;
+
+	if (unhand(this)->this_inner_index >= 0) {
+		innerClass	*ic = unhand(this)->inner_classes;
+
+		ret = getClass (ic[unhand(this)->this_inner_index].outer_class,
+				this,
+				&einfo);
+
+		if (ret == NULL)
+			throwError(&einfo);
+	}
+	return ret;
+}
+
+
 HArrayOfObject*
-java_lang_Class_getClasses0(struct Hjava_lang_Class* clazz, jboolean inner)
+java_lang_VMClass_getDeclaredClasses(struct Hjava_lang_Class* clazz, jboolean publicOnly)
 {
 	errorInfo einfo;
 	int count;
@@ -803,7 +778,8 @@ java_lang_Class_getClasses0(struct Hjava
 		}
 #else
 		/* assume one unique constant pool entry per class */
-		if (clazz->this_index == (inner ? ic->outer_class : ic->inner_class)) {
+		if ((clazz->this_index == ic->outer_class) &&
+		    ((ic->inner_class_accflags & ACC_PUBLIC) || !publicOnly) ) {
 			count++;
 		}
 #endif
@@ -830,11 +806,12 @@ java_lang_Class_getClasses0(struct Hjava
 		}
 #else
 		/* assume one unique constant pool entry per class */
-		if (clazz->this_index != (inner ? ic->outer_class : ic->inner_class)) {
+		if ((clazz->this_index != ic->outer_class) &&
+		    ((ic->inner_class_accflags & ACC_PUBLIC) || !publicOnly) ) {
 			continue;
 		}
 #endif
-		c = getClass (inner ? ic->inner_class : ic->outer_class, clazz, &einfo);
+		c = getClass (ic->inner_class, clazz, &einfo);
 		if (c == NULL) {
 			throwError(&einfo);
 		}
Index: libraries/clib/native/ClassLoader.c
===================================================================
RCS file: /cvs/kaffe/kaffe/libraries/clib/native/ClassLoader.c,v
retrieving revision 1.43
diff -u -p -r1.43 ClassLoader.c
--- libraries/clib/native/ClassLoader.c	1 Jan 2005 11:35:44 -0000	1.43
+++ libraries/clib/native/ClassLoader.c	5 Jan 2005 14:54:25 -0000
@@ -28,6 +28,32 @@
 #include "java_lang_VMClassLoader.h"
 #include "defs.h"
 
+struct Hjava_lang_Class*
+java_lang_VMClassLoader_getPrimitiveClass(jchar typeCode)
+{
+	switch(typeCode) {
+	case 'Z':
+		return (booleanClass);
+	case 'B':
+		return (byteClass);
+	case 'C':
+		return (charClass);
+	case 'D':
+		return (doubleClass);
+	case 'F':
+		return (floatClass);
+	case 'I':
+		return (intClass);
+	case 'J':
+		return (longClass);
+	case 'S':
+		return (shortClass);
+	case 'V':
+		return (voidClass);
+	}
+	return(NULL);
+}
+
 /*
  * Translate an array of bytes into a class.
  */
Index: kaffe/kaffevm/jni/jni.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jni/jni.c,v
retrieving revision 1.15
diff -u -p -r1.15 jni.c
--- kaffe/kaffevm/jni/jni.c	22 Dec 2004 00:22:05 -0000	1.15
+++ kaffe/kaffevm/jni/jni.c	5 Jan 2005 14:54:25 -0000
@@ -41,6 +41,7 @@
 #include "jni_funcs.h"
 #include "native-wrapper.h"
 #include "kaffe_jni.h"
+#include "stackTrace.h"
 
 extern struct JNINativeInterface Kaffe_JNINativeInterface;
 extern KaffeVM_Arguments Kaffe_JavaVMInitArgs;
@@ -219,9 +220,11 @@ Kaffe_DefineClass(JNIEnv* env, const cha
 static jclass
 Kaffe_FindClass(JNIEnv UNUSED *env, const char* name)
 {
+	stackTraceInfo*		info;
 	jstring nameString;
 	Utf8Const* utf8;
 	jvalue retval;
+	int			i;
 
 	BEGIN_EXCEPTION_HANDLING(NULL);
 
@@ -231,8 +234,38 @@ Kaffe_FindClass(JNIEnv UNUSED *env, cons
 	utf8ConstRelease(utf8);
 	checkPtr(nameString);
 
-	do_execute_java_class_method(&retval, "java.lang.Class", NULL,
-		"forName", "(Ljava/lang/String;)Ljava/lang/Class;", nameString);
+	info = (stackTraceInfo*)buildStackTrace(NULL);
+	if (info == NULL) {
+	}
+
+	i = 0;
+	for (;;) {
+		if (info[i].meth == ENDOFSTACK)
+			break;
+
+		if (info[i].meth != NULL)
+			break;
+		
+		i++;
+	}
+	       
+	if (info[i].meth == ENDOFSTACK) {
+		/* if there are no java methods on the stack, we use the system class loader */
+		do_execute_java_class_method (&retval, "java/lang/ClassLoader",
+					      NULL,
+					      "getSystemClassLoader",
+					      "()Ljava/lang/ClassLoader;");
+
+		do_execute_java_class_method(&retval, "java.lang.Class", NULL,
+					     "forName", "(Ljava/lang/String;ZLjava/lang/ClassLoader;)Ljava/lang/Class;",
+					     nameString, true, retval.l);
+	} else {
+		/* otherwise, we use the first java method on the stack */
+		do_execute_java_class_method(&retval, "java.lang.Class", NULL,
+					     "forName", "(Ljava/lang/String;ZLjava/lang/ClassLoader;)Ljava/lang/Class;",
+					     nameString, true, info[i].meth->class->loader);
+	}
+
 	ADD_REF(retval.l);
 
 	END_EXCEPTION_HANDLING();
